(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('rxjs/Subject'), require('rxjs/Observable'), require('rxjs/add/observable/merge'), require('rxjs/add/operator/map'), require('rxjs/add/operator/mergeMap'), require('rxjs/add/operator/takeUntil'), require('rxjs/add/operator/take'), require('rxjs/add/operator/takeLast'), require('rxjs/add/operator/pairwise'), require('rxjs/add/operator/share'), require('rxjs/add/operator/distinctUntilChanged'), require('rxjs/add/operator/filter'), require('rxjs/observable/merge'), require('rxjs/observable/interval'), require('rxjs/add/operator/throttle'), require('date-fns')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/forms', 'rxjs/Subject', 'rxjs/Observable', 'rxjs/add/observable/merge', 'rxjs/add/operator/map', 'rxjs/add/operator/mergeMap', 'rxjs/add/operator/takeUntil', 'rxjs/add/operator/take', 'rxjs/add/operator/takeLast', 'rxjs/add/operator/pairwise', 'rxjs/add/operator/share', 'rxjs/add/operator/distinctUntilChanged', 'rxjs/add/operator/filter', 'rxjs/observable/merge', 'rxjs/observable/interval', 'rxjs/add/operator/throttle', 'date-fns'], factory) :
	(factory((global['ngx-calendar'] = {}),global.ng.core,global.ng.common,global.ng.forms,global.Rx,global.Rx,global.Rx.Observable,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable.prototype,global.dateFns));
}(this, (function (exports,core,common,forms,Subject,Observable,merge,map,mergeMap,takeUntil,take,takeLast,pairwise,share,distinctUntilChanged,filter,merge$1,interval,throttle,dateFns) { 'use strict';

var DraggableHelper = (function () {
    function DraggableHelper() {
        this.currentDrag = new Subject.Subject();
    }
    return DraggableHelper;
}());
var MOVE_CURSOR = 'move';
var DraggableDirective = (function () {
    /**
     * @hidden
     */
    function DraggableDirective(element, renderer, draggableHelper, zone) {
        this.element = element;
        this.renderer = renderer;
        this.draggableHelper = draggableHelper;
        this.zone = zone;
        this.dragAxis = { x: true, y: true };
        this.dragSnapGrid = {};
        this.ghostDragEnabled = true;
        this.dragCursor = MOVE_CURSOR;
        this.dragStart = new core.EventEmitter();
        this.dragging = new core.EventEmitter();
        this.dragEnd = new core.EventEmitter();
        /**
         * @hidden
         */
        this.pointerDown = new Subject.Subject();
        /**
         * @hidden
         */
        this.pointerMove = new Subject.Subject();
        /**
         * @hidden
         */
        this.pointerUp = new Subject.Subject();
        this.eventListenerSubscriptions = {};
    }
    DraggableDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.checkEventListeners();
        var pointerDrag = this.pointerDown
            .filter(function () { return _this.canDrag(); })
            .flatMap(function (pointerDownEvent) {
            pointerDownEvent.event.preventDefault();
            _this.zone.run(function () {
                _this.dragStart.next({ x: 0, y: 0 });
            });
            _this.setCursor(_this.dragCursor);
            var currentDrag = new Subject.Subject();
            _this.draggableHelper.currentDrag.next(currentDrag);
            var pointerMove = _this.pointerMove
                .map(function (pointerMoveEvent) {
                pointerMoveEvent.event.preventDefault();
                return {
                    currentDrag: currentDrag,
                    x: pointerMoveEvent.clientX - pointerDownEvent.clientX,
                    y: pointerMoveEvent.clientY - pointerDownEvent.clientY,
                    clientX: pointerMoveEvent.clientX,
                    clientY: pointerMoveEvent.clientY
                };
            })
                .map(function (moveData) {
                if (_this.dragSnapGrid.x) {
                    moveData.x =
                        Math.floor(moveData.x / _this.dragSnapGrid.x) *
                            _this.dragSnapGrid.x;
                }
                if (_this.dragSnapGrid.y) {
                    moveData.y =
                        Math.floor(moveData.y / _this.dragSnapGrid.y) *
                            _this.dragSnapGrid.y;
                }
                return moveData;
            })
                .map(function (moveData) {
                if (!_this.dragAxis.x) {
                    moveData.x = 0;
                }
                if (!_this.dragAxis.y) {
                    moveData.y = 0;
                }
                return moveData;
            })
                .filter(function (_a) {
                var x = _a.x, y = _a.y;
                return !_this.validateDrag || _this.validateDrag({ x: x, y: y });
            })
                .takeUntil(Observable.Observable.merge(_this.pointerUp, _this.pointerDown));
            pointerMove.takeLast(1).subscribe(function (_a) {
                var x = _a.x, y = _a.y;
                _this.zone.run(function () {
                    _this.dragEnd.next({ x: x, y: y });
                });
                currentDrag.complete();
                _this.setCssTransform(null);
                if (_this.ghostDragEnabled) {
                    _this.renderer.setStyle(_this.element.nativeElement, 'pointerEvents', null);
                }
            });
            _this.pointerMove.next(pointerDownEvent);
            return pointerMove;
        })
            .share();
        Observable.Observable.merge(pointerDrag.take(1).map(function (value) { return [, value]; }), pointerDrag.pairwise())
            .filter(function (_a) {
            var previous = _a[0], next = _a[1];
            if (!previous) {
                return true;
            }
            return previous.x !== next.x || previous.y !== next.y;
        })
            .map(function (_a) {
            var previous = _a[0], next = _a[1];
            return next;
        })
            .subscribe(function (_a) {
            var x = _a.x, y = _a.y, currentDrag = _a.currentDrag, clientX = _a.clientX, clientY = _a.clientY;
            _this.zone.run(function () {
                _this.dragging.next({ x: x, y: y });
            });
            if (_this.ghostDragEnabled) {
                _this.renderer.setStyle(_this.element.nativeElement, 'pointerEvents', 'none');
            }
            _this.setCssTransform("translate(" + x + "px, " + y + "px)");
            currentDrag.next({
                clientX: clientX,
                clientY: clientY,
                dropData: _this.dropData
            });
        });
    };
    DraggableDirective.prototype.ngOnChanges = function (changes) {
        if (changes['dragAxis']) {
            this.checkEventListeners();
        }
    };
    DraggableDirective.prototype.ngOnDestroy = function () {
        this.unsubscribeEventListeners();
        this.pointerDown.complete();
        this.pointerMove.complete();
        this.pointerUp.complete();
    };
    DraggableDirective.prototype.checkEventListeners = function () {
        var _this = this;
        var canDrag = this.canDrag();
        var hasEventListeners = Object.keys(this.eventListenerSubscriptions).length > 0;
        if (canDrag && !hasEventListeners) {
            this.zone.runOutsideAngular(function () {
                _this.eventListenerSubscriptions.mousedown = _this.renderer.listen(_this.element.nativeElement, 'mousedown', function (event) {
                    _this.onMouseDown(event);
                });
                _this.eventListenerSubscriptions.mouseup = _this.renderer.listen('document', 'mouseup', function (event) {
                    _this.onMouseUp(event);
                });
                _this.eventListenerSubscriptions.touchstart = _this.renderer.listen(_this.element.nativeElement, 'touchstart', function (event) {
                    _this.onTouchStart(event);
                });
                _this.eventListenerSubscriptions.touchend = _this.renderer.listen('document', 'touchend', function (event) {
                    _this.onTouchEnd(event);
                });
                _this.eventListenerSubscriptions.touchcancel = _this.renderer.listen('document', 'touchcancel', function (event) {
                    _this.onTouchEnd(event);
                });
                _this.eventListenerSubscriptions.mouseenter = _this.renderer.listen(_this.element.nativeElement, 'mouseenter', function () {
                    _this.onMouseEnter();
                });
                _this.eventListenerSubscriptions.mouseleave = _this.renderer.listen(_this.element.nativeElement, 'mouseleave', function () {
                    _this.onMouseLeave();
                });
            });
        }
        else if (!canDrag && hasEventListeners) {
            this.unsubscribeEventListeners();
        }
    };
    DraggableDirective.prototype.onMouseDown = function (event) {
        var _this = this;
        if (!this.eventListenerSubscriptions.mousemove) {
            this.eventListenerSubscriptions.mousemove = this.renderer.listen('document', 'mousemove', function (mouseMoveEvent) {
                _this.pointerMove.next({
                    event: mouseMoveEvent,
                    clientX: mouseMoveEvent.clientX,
                    clientY: mouseMoveEvent.clientY
                });
            });
        }
        this.pointerDown.next({
            event: event,
            clientX: event.clientX,
            clientY: event.clientY
        });
    };
    DraggableDirective.prototype.onMouseUp = function (event) {
        if (this.eventListenerSubscriptions.mousemove) {
            this.eventListenerSubscriptions.mousemove();
            delete this.eventListenerSubscriptions.mousemove;
        }
        this.pointerUp.next({
            event: event,
            clientX: event.clientX,
            clientY: event.clientY
        });
    };
    DraggableDirective.prototype.onTouchStart = function (event) {
        var _this = this;
        if (!this.eventListenerSubscriptions.touchmove) {
            this.eventListenerSubscriptions.touchmove = this.renderer.listen('document', 'touchmove', function (touchMoveEvent) {
                _this.pointerMove.next({
                    event: touchMoveEvent,
                    clientX: touchMoveEvent.targetTouches[0].clientX,
                    clientY: touchMoveEvent.targetTouches[0].clientY
                });
            });
        }
        this.pointerDown.next({
            event: event,
            clientX: event.touches[0].clientX,
            clientY: event.touches[0].clientY
        });
    };
    DraggableDirective.prototype.onTouchEnd = function (event) {
        if (this.eventListenerSubscriptions.touchmove) {
            this.eventListenerSubscriptions.touchmove();
            delete this.eventListenerSubscriptions.touchmove;
        }
        this.pointerUp.next({
            event: event,
            clientX: event.changedTouches[0].clientX,
            clientY: event.changedTouches[0].clientY
        });
    };
    DraggableDirective.prototype.onMouseEnter = function () {
        this.setCursor(this.dragCursor);
    };
    DraggableDirective.prototype.onMouseLeave = function () {
        this.setCursor(null);
    };
    DraggableDirective.prototype.setCssTransform = function (value) {
        if (this.ghostDragEnabled) {
            this.renderer.setStyle(this.element.nativeElement, 'transform', value);
            this.renderer.setStyle(this.element.nativeElement, '-webkit-transform', value);
            this.renderer.setStyle(this.element.nativeElement, '-ms-transform', value);
            this.renderer.setStyle(this.element.nativeElement, '-moz-transform', value);
            this.renderer.setStyle(this.element.nativeElement, '-o-transform', value);
        }
    };
    DraggableDirective.prototype.canDrag = function () {
        return this.dragAxis.x || this.dragAxis.y;
    };
    DraggableDirective.prototype.setCursor = function (value) {
        this.renderer.setStyle(this.element.nativeElement, 'cursor', value);
    };
    DraggableDirective.prototype.unsubscribeEventListeners = function () {
        var _this = this;
        Object.keys(this.eventListenerSubscriptions).forEach(function (type) {
            _this.eventListenerSubscriptions[type]();
            delete _this.eventListenerSubscriptions[type];
        });
    };
    DraggableDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[mwlDraggable]'
                },] },
    ];
    /** @nocollapse */
    DraggableDirective.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
            { type: core.Renderer2, },
            { type: DraggableHelper, },
            { type: core.NgZone, },
        ];
    };
    DraggableDirective.propDecorators = {
        'dropData': [{ type: core.Input },],
        'dragAxis': [{ type: core.Input },],
        'dragSnapGrid': [{ type: core.Input },],
        'ghostDragEnabled': [{ type: core.Input },],
        'validateDrag': [{ type: core.Input },],
        'dragCursor': [{ type: core.Input },],
        'dragStart': [{ type: core.Output },],
        'dragging': [{ type: core.Output },],
        'dragEnd': [{ type: core.Output },],
    };
    return DraggableDirective;
}());
function isCoordinateWithinRectangle(clientX, clientY, rect) {
    return (clientX >= rect.left &&
        clientX <= rect.right &&
        clientY >= rect.top &&
        clientY <= rect.bottom);
}
var DroppableDirective = (function () {
    function DroppableDirective(element, draggableHelper, zone) {
        this.element = element;
        this.draggableHelper = draggableHelper;
        this.zone = zone;
        this.dragEnter = new core.EventEmitter();
        this.dragLeave = new core.EventEmitter();
        this.dragOver = new core.EventEmitter();
        this.drop = new core.EventEmitter();
    }
    DroppableDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.currentDragSubscription = this.draggableHelper.currentDrag.subscribe(function (drag) {
            var droppableRectangle = _this.element.nativeElement.getBoundingClientRect();
            var currentDragDropData;
            var overlaps = drag.map(function (_a) {
                var clientX = _a.clientX, clientY = _a.clientY, dropData = _a.dropData;
                currentDragDropData = dropData;
                return isCoordinateWithinRectangle(clientX, clientY, droppableRectangle);
            });
            var overlapsChanged = overlaps.distinctUntilChanged();
            var dragOverActive; // TODO - see if there's a way of doing this via rxjs
            overlapsChanged.filter(function (overlapsNow) { return overlapsNow; }).subscribe(function () {
                dragOverActive = true;
                _this.zone.run(function () {
                    _this.dragEnter.next({
                        dropData: currentDragDropData
                    });
                });
            });
            overlaps.filter(function (overlapsNow) { return overlapsNow; }).subscribe(function () {
                _this.zone.run(function () {
                    _this.dragOver.next({
                        dropData: currentDragDropData
                    });
                });
            });
            overlapsChanged
                .pairwise()
                .filter(function (_a) {
                var didOverlap = _a[0], overlapsNow = _a[1];
                return didOverlap && !overlapsNow;
            })
                .subscribe(function () {
                dragOverActive = false;
                _this.zone.run(function () {
                    _this.dragLeave.next({
                        dropData: currentDragDropData
                    });
                });
            });
            drag.flatMap(function () { return overlaps; }).subscribe({
                complete: function () {
                    if (dragOverActive) {
                        _this.zone.run(function () {
                            _this.drop.next({
                                dropData: currentDragDropData
                            });
                        });
                    }
                }
            });
        });
    };
    DroppableDirective.prototype.ngOnDestroy = function () {
        this.currentDragSubscription.unsubscribe();
    };
    DroppableDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[mwlDroppable]'
                },] },
    ];
    /** @nocollapse */
    DroppableDirective.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
            { type: DraggableHelper, },
            { type: core.NgZone, },
        ];
    };
    DroppableDirective.propDecorators = {
        'dragEnter': [{ type: core.Output },],
        'dragLeave': [{ type: core.Output },],
        'dragOver': [{ type: core.Output },],
        'drop': [{ type: core.Output },],
    };
    return DroppableDirective;
}());
var DragAndDropModule = (function () {
    function DragAndDropModule() {
    }
    DragAndDropModule.forRoot = function () {
        return {
            ngModule: DragAndDropModule,
            providers: [DraggableHelper]
        };
    };
    DragAndDropModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [DraggableDirective, DroppableDirective],
                    exports: [DraggableDirective, DroppableDirective]
                },] },
    ];
    /** @nocollapse */
    DragAndDropModule.ctorParameters = function () { return []; };
    return DragAndDropModule;
}());
/**
 * An element placed inside a `mwlResizable` directive to be used as a drag and resize handle
 *
 * For example
 *
 * ```
 * &lt;div mwlResizable&gt;
 *   &lt;div mwlResizeHandle [resizeEdges]="{bottom: true, right: true}"&gt;&lt;/div&gt;
 * &lt;/div&gt;
 * ```
 */
var ResizeHandle = (function () {
    function ResizeHandle(renderer, element, zone) {
        this.renderer = renderer;
        this.element = element;
        this.zone = zone;
        /**
         * The `Edges` object that contains the edges of the parent element that dragging the handle will trigger a resize on
         */
        this.resizeEdges = {};
        this.eventListeners = {};
    }
    ResizeHandle.prototype.ngOnDestroy = function () {
        this.unsubscribeEventListeners();
    };
    /**
     * @private
     */
    ResizeHandle.prototype.onMousedown = function (event, mouseX, mouseY) {
        var _this = this;
        event.preventDefault();
        this.zone.runOutsideAngular(function () {
            if (!_this.eventListeners.touchmove) {
                _this.eventListeners.touchmove = _this.renderer.listen(_this.element.nativeElement, 'touchmove', function (event) {
                    _this.onMousemove(event, event.targetTouches[0].clientX, event.targetTouches[0].clientY);
                });
            }
            if (!_this.eventListeners.mousemove) {
                _this.eventListeners.mousemove = _this.renderer.listen(_this.element.nativeElement, 'mousemove', function (event) {
                    _this.onMousemove(event, event.clientX, event.clientY);
                });
            }
            _this.resizable.mousedown.next({ mouseX: mouseX, mouseY: mouseY, edges: _this.resizeEdges });
        });
    };
    /**
     * @private
     */
    ResizeHandle.prototype.onMouseup = function (mouseX, mouseY) {
        var _this = this;
        this.zone.runOutsideAngular(function () {
            _this.unsubscribeEventListeners();
            _this.resizable.mouseup.next({ mouseX: mouseX, mouseY: mouseY, edges: _this.resizeEdges });
        });
    };
    ResizeHandle.prototype.onMousemove = function (event, mouseX, mouseY) {
        this.resizable.mousemove.next({ mouseX: mouseX, mouseY: mouseY, edges: this.resizeEdges, event: event });
    };
    ResizeHandle.prototype.unsubscribeEventListeners = function () {
        var _this = this;
        Object.keys(this.eventListeners).forEach(function (type) {
            _this.eventListeners[type]();
            delete _this.eventListeners[type];
        });
    };
    return ResizeHandle;
}());
ResizeHandle.decorators = [
    { type: core.Directive, args: [{
                selector: '[mwlResizeHandle]'
            },] },
];
/** @nocollapse */
ResizeHandle.ctorParameters = function () {
    return [
        { type: core.Renderer2, },
        { type: core.ElementRef, },
        { type: core.NgZone, },
    ];
};
ResizeHandle.propDecorators = {
    'resizeEdges': [{ type: core.Input },],
    'onMousedown': [{ type: core.HostListener, args: ['touchstart', ['$event', '$event.touches[0].clientX', '$event.touches[0].clientY'],] }, { type: core.HostListener, args: ['mousedown', ['$event', '$event.clientX', '$event.clientY'],] },],
    'onMouseup': [{ type: core.HostListener, args: ['touchend', ['$event.changedTouches[0].clientX', '$event.changedTouches[0].clientY'],] }, { type: core.HostListener, args: ['touchcancel', ['$event.changedTouches[0].clientX', '$event.changedTouches[0].clientY'],] }, { type: core.HostListener, args: ['mouseup', ['$event.clientX', '$event.clientY'],] },],
};
function isNumberCloseTo(value1, value2, precision) {
    if (precision === void 0) {
        precision = 3;
    }
    var diff = Math.abs(value1 - value2);
    return diff < precision;
}
function getNewBoundingRectangle(startingRect, edges, clientX, clientY) {
    var newBoundingRect = {
        top: startingRect.top,
        bottom: startingRect.bottom,
        left: startingRect.left,
        right: startingRect.right
    };
    if (edges.top) {
        newBoundingRect.top += clientY;
    }
    if (edges.bottom) {
        newBoundingRect.bottom += clientY;
    }
    if (edges.left) {
        newBoundingRect.left += clientX;
    }
    if (edges.right) {
        newBoundingRect.right += clientX;
    }
    newBoundingRect.height = newBoundingRect.bottom - newBoundingRect.top;
    newBoundingRect.width = newBoundingRect.right - newBoundingRect.left;
    return newBoundingRect;
}
function getElementRect(element, ghostElementPositioning) {
    if (ghostElementPositioning === 'absolute') {
        return {
            height: element.nativeElement.offsetHeight,
            width: element.nativeElement.offsetWidth,
            top: element.nativeElement.offsetTop,
            bottom: element.nativeElement.offsetHeight + element.nativeElement.offsetTop,
            left: element.nativeElement.offsetLeft,
            right: element.nativeElement.offsetWidth + element.nativeElement.offsetLeft
        };
    }
    else {
        var boundingRect = element.nativeElement.getBoundingClientRect();
        return {
            height: boundingRect.height,
            width: boundingRect.width,
            top: boundingRect.top,
            bottom: boundingRect.bottom,
            left: boundingRect.left,
            right: boundingRect.right,
            scrollTop: element.nativeElement.scrollTop,
            scrollLeft: element.nativeElement.scrollLeft
        };
    }
}
function isWithinBoundingY(_a) {
    var clientY = _a.clientY, rect = _a.rect;
    return clientY >= rect.top && clientY <= rect.bottom;
}
function isWithinBoundingX(_a) {
    var clientX = _a.clientX, rect = _a.rect;
    return clientX >= rect.left && clientX <= rect.right;
}
function getResizeEdges(_a) {
    var clientX = _a.clientX, clientY = _a.clientY, elm = _a.elm, allowedEdges = _a.allowedEdges, cursorPrecision = _a.cursorPrecision;
    var elmPosition = elm.nativeElement.getBoundingClientRect();
    var edges = {};
    if (allowedEdges.left &&
        isNumberCloseTo(clientX, elmPosition.left, cursorPrecision) &&
        isWithinBoundingY({ clientY: clientY, rect: elmPosition })) {
        edges.left = true;
    }
    if (allowedEdges.right &&
        isNumberCloseTo(clientX, elmPosition.right, cursorPrecision) &&
        isWithinBoundingY({ clientY: clientY, rect: elmPosition })) {
        edges.right = true;
    }
    if (allowedEdges.top &&
        isNumberCloseTo(clientY, elmPosition.top, cursorPrecision) &&
        isWithinBoundingX({ clientX: clientX, rect: elmPosition })) {
        edges.top = true;
    }
    if (allowedEdges.bottom &&
        isNumberCloseTo(clientY, elmPosition.bottom, cursorPrecision) &&
        isWithinBoundingX({ clientX: clientX, rect: elmPosition })) {
        edges.bottom = true;
    }
    return edges;
}
var DEFAULT_RESIZE_CURSORS = Object.freeze({
    topLeft: 'nw-resize',
    topRight: 'ne-resize',
    bottomLeft: 'sw-resize',
    bottomRight: 'se-resize',
    leftOrRight: 'ew-resize',
    topOrBottom: 'ns-resize'
});
function getResizeCursor(edges, cursors) {
    if (edges.left && edges.top) {
        return cursors.topLeft;
    }
    else if (edges.right && edges.top) {
        return cursors.topRight;
    }
    else if (edges.left && edges.bottom) {
        return cursors.bottomLeft;
    }
    else if (edges.right && edges.bottom) {
        return cursors.bottomRight;
    }
    else if (edges.left || edges.right) {
        return cursors.leftOrRight;
    }
    else if (edges.top || edges.bottom) {
        return cursors.topOrBottom;
    }
    else {
        return '';
    }
}
function getEdgesDiff(_a) {
    var edges = _a.edges, initialRectangle = _a.initialRectangle, newRectangle = _a.newRectangle;
    var edgesDiff = {};
    Object.keys(edges).forEach(function (edge) {
        edgesDiff[edge] = newRectangle[edge] - initialRectangle[edge];
    });
    return edgesDiff;
}
var RESIZE_ACTIVE_CLASS = 'resize-active';
var RESIZE_LEFT_HOVER_CLASS = 'resize-left-hover';
var RESIZE_RIGHT_HOVER_CLASS = 'resize-right-hover';
var RESIZE_TOP_HOVER_CLASS = 'resize-top-hover';
var RESIZE_BOTTOM_HOVER_CLASS = 'resize-bottom-hover';
var RESIZE_GHOST_ELEMENT_CLASS = 'resize-ghost-element';
var MOUSE_MOVE_THROTTLE_MS = 50;
/**
 * Place this on an element to make it resizable
 *
 * For example
 *
 * ```
 * &lt;div mwlResizable [resizeEdges]="{bottom: true, right: true, top: true, left: true}" [enableGhostResize]="true"&gt;&lt;/div&gt;
 * ```
 */
var Resizable = (function () {
    /**
     * @hidden
     */
    function Resizable(renderer, elm, zone) {
        this.renderer = renderer;
        this.elm = elm;
        this.zone = zone;
        /**
         * The edges that an element can be resized from. Pass an object like `{top: true, bottom: false}`. By default no edges can be resized.
         */
        this.resizeEdges = {};
        /**
         * Set to `true` to enable a temporary resizing effect of the element in between the `resizeStart` and `resizeEnd` events.
         */
        this.enableGhostResize = false;
        /**
         * A snap grid that resize events will be locked to.
         *
         * e.g. to only allow the element to be resized every 10px set it to `{left: 10, right: 10}`
         */
        this.resizeSnapGrid = {};
        /**
         * The mouse cursors that will be set on the resize edges
         */
        this.resizeCursors = DEFAULT_RESIZE_CURSORS;
        /**
         * Mouse over thickness to active cursor.
         */
        this.resizeCursorPrecision = 3;
        /**
         * Define the positioning of the ghost element (can be fixed or absolute)
         */
        this.ghostElementPositioning = 'fixed';
        /**
         * Called when the mouse is pressed and a resize event is about to begin. `$event` is a `ResizeEvent` object.
         */
        this.resizeStart = new core.EventEmitter();
        /**
         * Called as the mouse is dragged after a resize event has begun. `$event` is a `ResizeEvent` object.
         */
        this.resizing = new core.EventEmitter();
        /**
         * Called after the mouse is released after a resize event. `$event` is a `ResizeEvent` object.
         */
        this.resizeEnd = new core.EventEmitter();
        /**
         * @hidden
         */
        this.mouseup = new Subject.Subject();
        /**
         * @hidden
         */
        this.mousedown = new Subject.Subject();
        /**
         * @hidden
         */
        this.mousemove = new Subject.Subject();
        this.pointerEventListenerSubscriptions = {};
        this.pointerEventListeners = PointerEventListeners.getInstance(renderer, zone);
    }
    /**
     * @hidden
     */
    Resizable.prototype.ngOnInit = function () {
        var _this = this;
        // TODO - use some fancy Observable.merge's for this
        this.pointerEventListenerSubscriptions.pointerDown = this.pointerEventListeners.pointerDown.subscribe(function (_a) {
            var clientX = _a.clientX, clientY = _a.clientY;
            _this.mousedown.next({ clientX: clientX, clientY: clientY });
        });
        this.pointerEventListenerSubscriptions.pointerMove = this.pointerEventListeners.pointerMove.subscribe(function (_a) {
            var clientX = _a.clientX, clientY = _a.clientY, event = _a.event;
            _this.mousemove.next({ clientX: clientX, clientY: clientY, event: event });
        });
        this.pointerEventListenerSubscriptions.pointerUp = this.pointerEventListeners.pointerUp.subscribe(function (_a) {
            var clientX = _a.clientX, clientY = _a.clientY;
            _this.mouseup.next({ clientX: clientX, clientY: clientY });
        });
        var currentResize;
        var removeGhostElement = function () {
            if (currentResize.clonedNode) {
                _this.elm.nativeElement.parentElement.removeChild(currentResize.clonedNode);
                _this.renderer.setStyle(_this.elm.nativeElement, 'visibility', 'inherit');
            }
        };
        var mouseMove = this.mousemove.share();
        mouseMove
            .filter(function () { return !!currentResize; })
            .subscribe(function (_a) {
            var event = _a.event;
            event.preventDefault();
        });
        mouseMove.throttle(function (val) { return interval.interval(MOUSE_MOVE_THROTTLE_MS); }).subscribe(function (_a) {
            var clientX = _a.clientX, clientY = _a.clientY;
            var resizeEdges = getResizeEdges({
                clientX: clientX, clientY: clientY,
                elm: _this.elm,
                allowedEdges: _this.resizeEdges,
                cursorPrecision: _this.resizeCursorPrecision
            });
            var resizeCursors = Object.assign({}, DEFAULT_RESIZE_CURSORS, _this.resizeCursors);
            var cursor = currentResize ? '' : getResizeCursor(resizeEdges, resizeCursors);
            _this.renderer.setStyle(_this.elm.nativeElement, 'cursor', cursor);
            _this.setElementClass(_this.elm, RESIZE_ACTIVE_CLASS, !!currentResize);
            _this.setElementClass(_this.elm, RESIZE_LEFT_HOVER_CLASS, resizeEdges.left === true);
            _this.setElementClass(_this.elm, RESIZE_RIGHT_HOVER_CLASS, resizeEdges.right === true);
            _this.setElementClass(_this.elm, RESIZE_TOP_HOVER_CLASS, resizeEdges.top === true);
            _this.setElementClass(_this.elm, RESIZE_BOTTOM_HOVER_CLASS, resizeEdges.bottom === true);
        });
        var mousedrag = this.mousedown.flatMap(function (startCoords) {
            var getDiff = function (moveCoords) {
                return {
                    clientX: moveCoords.clientX - startCoords.clientX,
                    clientY: moveCoords.clientY - startCoords.clientY
                };
            };
            var getSnapGrid = function () {
                var snapGrid = { x: 1, y: 1 };
                if (currentResize) {
                    if (_this.resizeSnapGrid.left && currentResize.edges.left) {
                        snapGrid.x = +_this.resizeSnapGrid.left;
                    }
                    else if (_this.resizeSnapGrid.right && currentResize.edges.right) {
                        snapGrid.x = +_this.resizeSnapGrid.right;
                    }
                    if (_this.resizeSnapGrid.top && currentResize.edges.top) {
                        snapGrid.y = +_this.resizeSnapGrid.top;
                    }
                    else if (_this.resizeSnapGrid.bottom && currentResize.edges.bottom) {
                        snapGrid.y = +_this.resizeSnapGrid.bottom;
                    }
                }
                return snapGrid;
            };
            var getGrid = function (coords, snapGrid) {
                return {
                    x: Math.ceil(coords.clientX / snapGrid.x),
                    y: Math.ceil(coords.clientY / snapGrid.y)
                };
            };
            return merge$1.merge(mouseMove.take(1).map(function (coords) { return [, coords]; }), mouseMove.pairwise()).map(function (_a) {
                var previousCoords = _a[0], newCoords = _a[1];
                return [previousCoords ? getDiff(previousCoords) : previousCoords, getDiff(newCoords)];
            }).filter(function (_a) {
                var previousCoords = _a[0], newCoords = _a[1];
                if (!previousCoords) {
                    return true;
                }
                var snapGrid = getSnapGrid();
                var previousGrid = getGrid(previousCoords, snapGrid);
                var newGrid = getGrid(newCoords, snapGrid);
                return (previousGrid.x !== newGrid.x || previousGrid.y !== newGrid.y);
            }).map(function (_a) {
                var newCoords = _a[1];
                var snapGrid = getSnapGrid();
                return {
                    clientX: Math.round(newCoords.clientX / snapGrid.x) * snapGrid.x,
                    clientY: Math.round(newCoords.clientY / snapGrid.y) * snapGrid.y
                };
            }).takeUntil(merge$1.merge(_this.mouseup, _this.mousedown));
        }).filter(function () { return !!currentResize; });
        mousedrag.map(function (_a) {
            var clientX = _a.clientX, clientY = _a.clientY;
            return getNewBoundingRectangle(currentResize.startingRect, currentResize.edges, clientX, clientY);
        }).filter(function (newBoundingRect) {
            return newBoundingRect.height > 0 && newBoundingRect.width > 0;
        }).filter(function (newBoundingRect) {
            return _this.validateResize ? _this.validateResize({
                rectangle: newBoundingRect,
                edges: getEdgesDiff({
                    edges: currentResize.edges,
                    initialRectangle: currentResize.startingRect,
                    newRectangle: newBoundingRect
                })
            }) : true;
        }).subscribe(function (newBoundingRect) {
            if (currentResize.clonedNode) {
                _this.renderer.setStyle(currentResize.clonedNode, 'height', newBoundingRect.height + "px");
                _this.renderer.setStyle(currentResize.clonedNode, 'width', newBoundingRect.width + "px");
                _this.renderer.setStyle(currentResize.clonedNode, 'top', newBoundingRect.top + "px");
                _this.renderer.setStyle(currentResize.clonedNode, 'left', newBoundingRect.left + "px");
            }
            _this.zone.run(function () {
                _this.resizing.emit({
                    edges: getEdgesDiff({
                        edges: currentResize.edges,
                        initialRectangle: currentResize.startingRect,
                        newRectangle: newBoundingRect
                    }),
                    rectangle: newBoundingRect
                });
            });
            currentResize.currentRect = newBoundingRect;
        });
        this.mousedown.map(function (_a) {
            var clientX = _a.clientX, clientY = _a.clientY, edges = _a.edges;
            return edges || getResizeEdges({
                clientX: clientX, clientY: clientY,
                elm: _this.elm,
                allowedEdges: _this.resizeEdges,
                cursorPrecision: _this.resizeCursorPrecision
            });
        }).filter(function (edges) {
            return Object.keys(edges).length > 0;
        }).subscribe(function (edges) {
            if (currentResize) {
                removeGhostElement();
            }
            var startingRect = getElementRect(_this.elm, _this.ghostElementPositioning);
            currentResize = {
                edges: edges,
                startingRect: startingRect,
                currentRect: startingRect
            };
            if (_this.enableGhostResize) {
                currentResize.clonedNode = _this.elm.nativeElement.cloneNode(true);
                var resizeCursors = Object.assign({}, DEFAULT_RESIZE_CURSORS, _this.resizeCursors);
                _this.elm.nativeElement.parentElement.appendChild(currentResize.clonedNode);
                _this.renderer.setStyle(_this.elm.nativeElement, 'visibility', 'hidden');
                _this.renderer.setStyle(currentResize.clonedNode, 'position', _this.ghostElementPositioning);
                _this.renderer.setStyle(currentResize.clonedNode, 'left', currentResize.startingRect.left + "px");
                _this.renderer.setStyle(currentResize.clonedNode, 'top', currentResize.startingRect.top + "px");
                _this.renderer.setStyle(currentResize.clonedNode, 'height', currentResize.startingRect.height + "px");
                _this.renderer.setStyle(currentResize.clonedNode, 'width', currentResize.startingRect.width + "px");
                _this.renderer.setStyle(currentResize.clonedNode, 'cursor', getResizeCursor(currentResize.edges, resizeCursors));
                _this.renderer.addClass(currentResize.clonedNode, RESIZE_GHOST_ELEMENT_CLASS);
                currentResize.clonedNode.scrollTop = currentResize.startingRect.scrollTop;
                currentResize.clonedNode.scrollLeft = currentResize.startingRect.scrollLeft;
            }
            _this.zone.run(function () {
                _this.resizeStart.emit({
                    edges: getEdgesDiff({ edges: edges, initialRectangle: startingRect, newRectangle: startingRect }),
                    rectangle: getNewBoundingRectangle(startingRect, {}, 0, 0)
                });
            });
        });
        this.mouseup.subscribe(function () {
            if (currentResize) {
                _this.renderer.removeClass(_this.elm.nativeElement, RESIZE_ACTIVE_CLASS);
                _this.zone.run(function () {
                    _this.resizeEnd.emit({
                        edges: getEdgesDiff({
                            edges: currentResize.edges,
                            initialRectangle: currentResize.startingRect,
                            newRectangle: currentResize.currentRect
                        }),
                        rectangle: currentResize.currentRect
                    });
                });
                removeGhostElement();
                currentResize = null;
            }
        });
    };
    /**
     * @hidden
     */
    Resizable.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.resizeHandles.forEach(function (handle) {
            handle.resizable = _this;
        });
    };
    /**
     * @hidden
     */
    Resizable.prototype.ngOnDestroy = function () {
        this.mousedown.complete();
        this.mouseup.complete();
        this.mousemove.complete();
        this.pointerEventListenerSubscriptions.pointerDown.unsubscribe();
        this.pointerEventListenerSubscriptions.pointerMove.unsubscribe();
        this.pointerEventListenerSubscriptions.pointerUp.unsubscribe();
    };
    Resizable.prototype.setElementClass = function (elm, name, add) {
        if (add) {
            this.renderer.addClass(elm.nativeElement, name);
        }
        else {
            this.renderer.removeClass(elm.nativeElement, name);
        }
    };
    return Resizable;
}());
Resizable.decorators = [
    { type: core.Directive, args: [{
                selector: '[mwlResizable]'
            },] },
];
/** @nocollapse */
Resizable.ctorParameters = function () {
    return [
        { type: core.Renderer2, },
        { type: core.ElementRef, },
        { type: core.NgZone, },
    ];
};
Resizable.propDecorators = {
    'validateResize': [{ type: core.Input },],
    'resizeEdges': [{ type: core.Input },],
    'enableGhostResize': [{ type: core.Input },],
    'resizeSnapGrid': [{ type: core.Input },],
    'resizeCursors': [{ type: core.Input },],
    'resizeCursorPrecision': [{ type: core.Input },],
    'ghostElementPositioning': [{ type: core.Input },],
    'resizeStart': [{ type: core.Output },],
    'resizing': [{ type: core.Output },],
    'resizeEnd': [{ type: core.Output },],
    'resizeHandles': [{ type: core.ContentChildren, args: [ResizeHandle,] },],
};
var PointerEventListeners = (function () {
    function PointerEventListeners(renderer, zone) {
        this.pointerDown = new Observable.Observable(function (observer) {
            var unsubscribeMouseDown, unsubscribeTouchStart;
            zone.runOutsideAngular(function () {
                unsubscribeMouseDown = renderer.listen('document', 'mousedown', function (event) {
                    observer.next({ clientX: event.clientX, clientY: event.clientY, event: event });
                });
                unsubscribeTouchStart = renderer.listen('document', 'touchstart', function (event) {
                    observer.next({ clientX: event.touches[0].clientX, clientY: event.touches[0].clientY, event: event });
                });
            });
            return function () {
                unsubscribeMouseDown();
                unsubscribeTouchStart();
            };
        }).share();
        this.pointerMove = new Observable.Observable(function (observer) {
            var unsubscribeMouseMove, unsubscribeTouchMove;
            zone.runOutsideAngular(function () {
                unsubscribeMouseMove = renderer.listen('document', 'mousemove', function (event) {
                    observer.next({ clientX: event.clientX, clientY: event.clientY, event: event });
                });
                unsubscribeTouchMove = renderer.listen('document', 'touchmove', function (event) {
                    observer.next({ clientX: event.targetTouches[0].clientX, clientY: event.targetTouches[0].clientY, event: event });
                });
            });
            return function () {
                unsubscribeMouseMove();
                unsubscribeTouchMove();
            };
        }).share();
        this.pointerUp = new Observable.Observable(function (observer) {
            var unsubscribeMouseUp, unsubscribeTouchEnd, unsubscribeTouchCancel;
            zone.runOutsideAngular(function () {
                unsubscribeMouseUp = renderer.listen('document', 'mouseup', function (event) {
                    observer.next({ clientX: event.clientX, clientY: event.clientY, event: event });
                });
                unsubscribeTouchEnd = renderer.listen('document', 'touchend', function (event) {
                    observer.next({ clientX: event.changedTouches[0].clientX, clientY: event.changedTouches[0].clientY, event: event });
                });
                unsubscribeTouchCancel = renderer.listen('document', 'touchcancel', function (event) {
                    observer.next({ clientX: event.changedTouches[0].clientX, clientY: event.changedTouches[0].clientY, event: event });
                });
            });
            return function () {
                unsubscribeMouseUp();
                unsubscribeTouchEnd();
                unsubscribeTouchCancel();
            };
        }).share();
    }
    PointerEventListeners.getInstance = function (renderer, zone) {
        if (!PointerEventListeners.instance) {
            PointerEventListeners.instance = new PointerEventListeners(renderer, zone);
        }
        return PointerEventListeners.instance;
    };
    return PointerEventListeners;
}());
var ResizableModule = (function () {
    function ResizableModule() {
    }
    return ResizableModule;
}());
ResizableModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [Resizable, ResizeHandle],
                exports: [Resizable, ResizeHandle]
            },] },
];
/** @nocollapse */
ResizableModule.ctorParameters = function () { return []; };
// tslint:disable-line
/**
 * @param {?} __0
 * @return {?}
 */
function getEventsInPeriod(_b) {
    var events = _b.events, periodStart = _b.periodStart, periodEnd = _b.periodEnd;
    return events.filter(function (event) { return isEventIsPeriod({ event: event, periodStart: periodStart, periodEnd: periodEnd }); });
}
/**
 * @param {?} __0
 * @return {?}
 */
function isEventIsPeriod(_b) {
    var event = _b.event, periodStart = _b.periodStart, periodEnd = _b.periodEnd;
    var /** @type {?} */ eventStart = event.start;
    var /** @type {?} */ eventEnd = event.end || event.start;
    if (eventStart > periodStart && eventStart < periodEnd) {
        return true;
    }
    if (eventEnd > periodStart && eventEnd < periodEnd) {
        return true;
    }
    if (eventStart < periodStart && eventEnd > periodEnd) {
        return true;
    }
    if (dateFns.isSameSecond(eventStart, periodStart) ||
        dateFns.isSameSecond(eventStart, periodEnd)) {
        return true;
    }
    if (dateFns.isSameSecond(eventEnd, periodStart) ||
        dateFns.isSameSecond(eventEnd, periodEnd)) {
        return true;
    }
    return false;
}
var MINUTES_IN_HOUR$1 = 60;
var HOURS_IN_DAY = 24;
/**
 * @param {?} __0
 * @return {?}
 */
function getDayView(_b) {
    var _c = _b.events, events = _c === void 0 ? [] : _c, viewDate = _b.viewDate, hourSegments = _b.hourSegments, dayStart = _b.dayStart, dayEnd = _b.dayEnd, eventWidth = _b.eventWidth, segmentHeight = _b.segmentHeight;
    if (!events) {
        events = [];
    }
    var /** @type {?} */ startOfView = dateFns.setMinutes(dateFns.setHours(dateFns.startOfDay(viewDate), dayStart.hour), dayStart.minute);
    var /** @type {?} */ endOfView = dateFns.setMinutes(dateFns.setHours(dateFns.startOfMinute(dateFns.endOfDay(viewDate)), dayEnd.hour), dayEnd.minute);
    var /** @type {?} */ previousDayEvents = [];
    var /** @type {?} */ dayViewEvents = getEventsInPeriod({
        events: events.filter(function (event) { return !event.allDay; }),
        periodStart: startOfView,
        periodEnd: endOfView
    })
        .sort(function (eventA, eventB) {
        return eventA.start.valueOf() - eventB.start.valueOf();
    })
        .map(function (event) {
        var /** @type {?} */ eventStart = event.start;
        var /** @type {?} */ eventEnd = event.end || eventStart;
        var /** @type {?} */ startsBeforeDay = eventStart < startOfView;
        var /** @type {?} */ endsAfterDay = eventEnd > endOfView;
        var /** @type {?} */ hourHeightModifier = hourSegments * segmentHeight / MINUTES_IN_HOUR$1;
        var /** @type {?} */ top = 0;
        if (eventStart > startOfView) {
            top += dateFns.differenceInMinutes(eventStart, startOfView);
        }
        top *= hourHeightModifier;
        var /** @type {?} */ startDate = startsBeforeDay ? startOfView : eventStart;
        var /** @type {?} */ endDate = endsAfterDay ? endOfView : eventEnd;
        var /** @type {?} */ height = dateFns.differenceInMinutes(endDate, startDate);
        if (!event.end) {
            height = segmentHeight;
        }
        else {
            height *= hourHeightModifier;
        }
        var /** @type {?} */ bottom = top + height;
        var /** @type {?} */ overlappingPreviousEvents = previousDayEvents.filter(function (previousEvent) {
            var /** @type {?} */ previousEventTop = previousEvent.top;
            var /** @type {?} */ previousEventBottom = previousEvent.top + previousEvent.height;
            if (top < previousEventBottom && previousEventBottom < bottom) {
                return true;
            }
            else if (previousEventTop <= top && bottom <= previousEventBottom) {
                return true;
            }
            return false;
        });
        var /** @type {?} */ left = 0;
        while (overlappingPreviousEvents.some(function (previousEvent) { return previousEvent.left === left; })) {
            left += eventWidth;
        }
        var /** @type {?} */ dayEvent = {
            event: event,
            height: height,
            width: eventWidth,
            top: top,
            left: left,
            startsBeforeDay: startsBeforeDay,
            endsAfterDay: endsAfterDay
        };
        if (height > 0) {
            previousDayEvents.push(dayEvent);
        }
        return dayEvent;
    })
        .filter(function (dayEvent) { return dayEvent.height > 0; });
    var /** @type {?} */ width = Math.max.apply(Math, dayViewEvents.map(function (event) { return event.left + event.width; }));
    var /** @type {?} */ allDayEvents = getEventsInPeriod({
        events: events.filter(function (event) { return event.allDay; }),
        periodStart: dateFns.startOfDay(startOfView),
        periodEnd: dateFns.endOfDay(endOfView)
    });
    return {
        events: dayViewEvents,
        width: width,
        allDayEvents: allDayEvents
    };
}
/**
 * @param {?} __0
 * @return {?}
 */
function getDayViewHourGrid(_b) {
    var viewDate = _b.viewDate, hourSegments = _b.hourSegments, dayStart = _b.dayStart, dayEnd = _b.dayEnd;
    var /** @type {?} */ hours = [];
    var /** @type {?} */ startOfView = dateFns.setMinutes(dateFns.setHours(dateFns.startOfDay(viewDate), dayStart.hour), dayStart.minute);
    var /** @type {?} */ endOfView = dateFns.setMinutes(dateFns.setHours(dateFns.startOfMinute(dateFns.endOfDay(viewDate)), dayEnd.hour), dayEnd.minute);
    var /** @type {?} */ segmentDuration = MINUTES_IN_HOUR$1 / hourSegments;
    var /** @type {?} */ startOfViewDay = dateFns.startOfDay(viewDate);
    for (var /** @type {?} */ i = 0; i < HOURS_IN_DAY; i++) {
        var /** @type {?} */ segments = [];
        for (var /** @type {?} */ j = 0; j < hourSegments; j++) {
            var /** @type {?} */ date = dateFns.addMinutes(dateFns.addHours(startOfViewDay, i), j * segmentDuration);
            if (date >= startOfView && date < endOfView) {
                segments.push({
                    date: date,
                    isStart: j === 0
                });
            }
        }
        if (segments.length > 0) {
            hours.push({ segments: segments });
        }
    }
    return hours;
}
var DAYS_IN_WEEK = 7;
var HOURS_IN_DAY$1 = 24;
var DAYS_OF_WEEK = {};
DAYS_OF_WEEK.SUNDAY = 0;
DAYS_OF_WEEK.MONDAY = 1;
DAYS_OF_WEEK.TUESDAY = 2;
DAYS_OF_WEEK.WEDNESDAY = 3;
DAYS_OF_WEEK.THURSDAY = 4;
DAYS_OF_WEEK.FRIDAY = 5;
DAYS_OF_WEEK.SATURDAY = 6;
DAYS_OF_WEEK[DAYS_OF_WEEK.SUNDAY] = "SUNDAY";
DAYS_OF_WEEK[DAYS_OF_WEEK.MONDAY] = "MONDAY";
DAYS_OF_WEEK[DAYS_OF_WEEK.TUESDAY] = "TUESDAY";
DAYS_OF_WEEK[DAYS_OF_WEEK.WEDNESDAY] = "WEDNESDAY";
DAYS_OF_WEEK[DAYS_OF_WEEK.THURSDAY] = "THURSDAY";
DAYS_OF_WEEK[DAYS_OF_WEEK.FRIDAY] = "FRIDAY";
DAYS_OF_WEEK[DAYS_OF_WEEK.SATURDAY] = "SATURDAY";
var DEFAULT_WEEKEND_DAYS = [
    DAYS_OF_WEEK.SUNDAY,
    DAYS_OF_WEEK.SATURDAY
];
/**
 * @param {?} __0
 * @return {?}
 */
function getWeekViewHeader(_b) {
    var viewDate = _b.viewDate, weekStartsOn = _b.weekStartsOn, _c = _b.excluded, excluded = _c === void 0 ? [] : _c, _d = _b.weekendDays, weekendDays = _d === void 0 ? [] : _d;
    var /** @type {?} */ start = dateFns.startOfWeek(viewDate, { weekStartsOn: weekStartsOn });
    var /** @type {?} */ days = [];
    var _loop_1 = function (i) {
        var /** @type {?} */ date = dateFns.addDays(start, i);
        if (!excluded.some(function (e) { return date.getDay() === e; })) {
            days.push(getWeekDay({ date: date, weekendDays: weekendDays }));
        }
    };
    for (var /** @type {?} */ i = 0; i < DAYS_IN_WEEK; i++) {
        _loop_1(/** @type {?} */ i);
    }
    return days;
}
/**
 * @param {?} __0
 * @return {?}
 */
function getWeekDay(_b) {
    var date = _b.date, _c = _b.weekendDays, weekendDays = _c === void 0 ? DEFAULT_WEEKEND_DAYS : _c;
    var /** @type {?} */ today = dateFns.startOfDay(new Date());
    return {
        date: date,
        isPast: date < today,
        isToday: dateFns.isSameDay(date, today),
        isFuture: date > today,
        isWeekend: weekendDays.indexOf(dateFns.getDay(date)) > -1
    };
}
/**
 * @param {?} __0
 * @return {?}
 */
function getMonthViewGrid(_b) {
    var events = _b.events, viewDate = _b.viewDate, weekStartsOn = _b.weekStartsOn, _c = _b.excluded, excluded = _c === void 0 ? [] : _c, _d = _b.viewStart, viewStart = _d === void 0 ? dateFns.startOfMonth(viewDate) : _d, _e = _b.viewEnd, viewEnd = _e === void 0 ? dateFns.endOfMonth(viewDate) : _e, weekendDays = _b.weekendDays;
    var /** @type {?} */ start = dateFns.startOfWeek(viewStart, { weekStartsOn: weekStartsOn });
    var /** @type {?} */ end = dateFns.endOfWeek(viewEnd, { weekStartsOn: weekStartsOn });
    var /** @type {?} */ monthRows = (dateFns.differenceInDays(end, start) + 1) / 7;
    var /** @type {?} */ width;
    var /** @type {?} */ left;
    var /** @type {?} */ weeks = [];
    var _loop_2 = function (week) {
        var /** @type {?} */ endWeek = dateFns.addDays(start, DAYS_IN_WEEK);
        var /** @type {?} */ eventsInWeek = [];
        var /** @type {?} */ eventsInPeriod = getEventsInPeriod({
            events: events,
            periodStart: start,
            periodEnd: endWeek
        }).map(function (event) {
            var /** @type {?} */ top = 28;
            var /** @type {?} */ hidden = false;
            if (dateFns.differenceInHours(event.end, event.start) > dateFns.differenceInHours(endWeek, event.start)) {
                width = (dateFns.differenceInHours(endWeek, event.start) / 168) * 100;
            }
            else {
                width = (dateFns.differenceInHours(event.end, event.start) / 168) * 100;
            }
            if (dateFns.isBefore(event.start, start)) {
                left = 0;
                width = (dateFns.differenceInHours(event.end, start) / 168) * 100;
            }
            else {
                left = (dateFns.differenceInHours(event.start, start) / 168) * 100;
            }
            if (!event.allDay) {
                left = (dateFns.differenceInHours(dateFns.startOfDay(event.start), start) / 168) * 100;
            }
            if (width > 100) {
                width = 100;
            }
            top = getTop(event, eventsInWeek, top);
            if (top > 60) {
                hidden = true;
            }
            eventsInWeek.push({
                event: event,
                left: left,
                width: width,
                top: top,
                hidden: hidden
            });
            return {
                event: event,
                left: left,
                width: width,
                top: top,
                hidden: hidden
            };
        });
        var /** @type {?} */ previousDate = null;
        var /** @type {?} */ weekDays = [];
        var _loop_3 = function (i) {
            var /** @type {?} */ date;
            if (previousDate) {
                date = dateFns.startOfDay(dateFns.addHours(previousDate, HOURS_IN_DAY$1));
                if (previousDate.getTime() === date.getTime()) {
                    date = dateFns.startOfDay(dateFns.addHours(previousDate, HOURS_IN_DAY$1 + 1));
                }
                previousDate = date;
            }
            else {
                date = previousDate = start;
            }
            if (!excluded.some(function (e) { return date.getDay() === e; })) {
                var /** @type {?} */ day = (getWeekDay({
                    date: date,
                    weekendDays: []
                }));
                var /** @type {?} */ dayEvents = getEventsInPeriod({
                    events: events,
                    periodStart: dateFns.startOfDay(date),
                    periodEnd: dateFns.endOfDay(date),
                });
                day.inMonth = dateFns.isSameMonth(date, viewDate);
                day.badgeTotal = dayEvents.length;
                day.events = dayEvents;
                weekDays.push(day);
            }
        };
        for (var /** @type {?} */ i = 0; i < dateFns.differenceInDays(endWeek, start); i++) {
            _loop_3(/** @type {?} */ i);
        }
        weeks.push({
            events: eventsInPeriod,
            days: weekDays
        });
        start = dateFns.addHours(start, (DAYS_IN_WEEK * HOURS_IN_DAY$1));
    };
    for (var /** @type {?} */ week = 0; week < monthRows; week++) {
        _loop_2(/** @type {?} */ week);
    }
    return {
        rowOffsets: weeks
    };
}
/**
 * @param {?} event
 * @param {?} events
 * @param {?} top
 * @return {?}
 */
function getTop(event, events, top) {
    var /** @type {?} */ over = [];
    var /** @type {?} */ tops = [28, 52, 76];
    for (var _i = 0, events_1 = events; _i < events_1.length; _i++) {
        var e = events_1[_i];
        if ((dateFns.isSameDay(event.start, e.event.start) || dateFns.isSameDay(event.end, e.event.end)) ||
            dateFns.isWithinRange(event.start, e.event.start, e.event.end) ||
            dateFns.isWithinRange(event.end, e.event.start, e.event.end) ||
            dateFns.isWithinRange(e.event.start, event.start, event.end) ||
            dateFns.isWithinRange(e.event.end, event.start, event.end)) {
            top = e.top + 24;
            over.push(e);
        }
    }
    for (var _b = 0, over_1 = over; _b < over_1.length; _b++) {
        var o = over_1[_b];
        for (var _c = 0, tops_1 = tops; _c < tops_1.length; _c++) {
            var t = tops_1[_c];
            if (o.top === t) {
                var /** @type {?} */ index = tops.indexOf(t);
                tops.splice(index, 1);
            }
        }
    }
    if (tops.length > 0) {
        top = tops[0];
    }
    return top;
}
var DAYS_IN_WEEK$1 = 7;
var HOURS_IN_DAY$2 = 24;
var MINUTES_IN_HOUR$2 = 60;
var SECONDS_IN_DAY = 60 * 60 * 24;
var SECONDS_IN_WEEK = SECONDS_IN_DAY * DAYS_IN_WEEK$1;
/**
 * @param {?} __0
 * @return {?}
 */
function getWeekView(_b) {
    var _c = _b.events, events = _c === void 0 ? [] : _c, viewDate = _b.viewDate, hourSegments = _b.hourSegments, dayStart = _b.dayStart, dayEnd = _b.dayEnd, segmentHeight = _b.segmentHeight, weekStartsOn = _b.weekStartsOn;
    var /** @type {?} */ startOfViewWeek = dateFns.startOfWeek(viewDate, { weekStartsOn: weekStartsOn });
    var /** @type {?} */ endOfViewWeek = dateFns.endOfWeek(viewDate, { weekStartsOn: weekStartsOn });
    var /** @type {?} */ weekCols = dateFns.differenceInDays(endOfViewWeek, startOfViewWeek) + 1;
    var /** @type {?} */ previousDate = startOfViewWeek;
    var /** @type {?} */ days = [];
    var /** @type {?} */ dayEvents = [];
    var _loop_4 = function (day) {
        var /** @type {?} */ startDay = dateFns.startOfDay(previousDate);
        var /** @type {?} */ endDay = dateFns.endOfDay(previousDate);
        var /** @type {?} */ eventsInDay = getEventsInPeriod({
            events: events.filter(function (event) { return !event.allDay; }),
            periodStart: startDay,
            periodEnd: endDay
        }).map(function (event) {
            var /** @type {?} */ top;
            var /** @type {?} */ height;
            if (dateFns.isBefore(event.start, startDay)) {
                top = 0;
                height = dateFns.differenceInMinutes(event.end, startDay);
            }
            else {
                top = dateFns.differenceInMinutes(event.start, startDay);
                height = dateFns.differenceInMinutes(event.end, event.start);
            }
            if (dateFns.isAfter(event.end, endDay)) {
                height = dateFns.differenceInMinutes(endDay, event.start);
            }
            dayEvents.push({
                event: event,
                top: top,
                height: height
            });
            return {
                event: event,
                top: top,
                height: height
            };
        });
        var /** @type {?} */ dayCols = dateFns.differenceInHours(endDay, startDay) + 1;
        var /** @type {?} */ previousHour = startDay;
        var /** @type {?} */ hours = [];
        for (var /** @type {?} */ hour = 0; hour < dayCols; hour++) {
            var /** @type {?} */ eventsInHour = getEventsInPeriod({
                events: events,
                periodStart: dateFns.startOfHour(previousHour),
                periodEnd: dateFns.endOfHour(previousHour)
            });
            hours.push({
                hour: previousHour,
                events: eventsInHour
            });
            previousHour = dateFns.startOfHour(dateFns.addMinutes(previousHour, MINUTES_IN_HOUR$2 + 1));
        }
        days.push({
            date: previousDate,
            isToday: dateFns.isSameDay(previousDate, new Date()),
            hours: hours,
            events: eventsInDay
        });
        previousDate = dateFns.startOfDay(dateFns.addHours(previousDate, HOURS_IN_DAY$2 + 1));
    };
    for (var /** @type {?} */ day = 0; day < weekCols; day++) {
        _loop_4(/** @type {?} */ day);
    }
    var /** @type {?} */ allDayWeekEvents = getEventsInPeriod({
        events: events.filter(function (event) { return event.allDay; }),
        periodStart: startOfViewWeek,
        periodEnd: endOfViewWeek
    });
    var /** @type {?} */ allDayEventsMapped = allDayWeekEvents.map(function (event) {
        var /** @type {?} */ eventStart = event.start;
        var /** @type {?} */ eventEnd = event.end || eventStart;
        var /** @type {?} */ startsBeforeWeek = eventStart < startOfViewWeek;
        var /** @type {?} */ endsAfterWeek = eventEnd > endOfViewWeek;
        var /** @type {?} */ offset = getWeekViewEventOffset({
            event: event,
            startOfWeek: startOfViewWeek,
            excluded: [],
            precision: 'days'
        });
        var /** @type {?} */ span = getWeekViewEventSpan({
            event: event,
            offset: offset,
            startOfWeekDate: startOfViewWeek,
            excluded: [],
            precision: 'days'
        });
        return {
            event: event,
            span: span,
            offset: offset,
            startsBeforeWeek: startsBeforeWeek,
            endsAfterWeek: endsAfterWeek
        };
    });
    return {
        days: days,
        allDays: allDayEventsMapped
    };
}
/**
 * @param {?} __0
 * @return {?}
 */
function getWeekViewEventSpan(_b) {
    var event = _b.event, offset = _b.offset, startOfWeekDate = _b.startOfWeekDate, excluded = _b.excluded, _c = _b.precision, precision = _c === void 0 ? 'days' : _c;
    var /** @type {?} */ span = SECONDS_IN_DAY;
    var /** @type {?} */ begin = dateFns.max(event.start, startOfWeekDate);
    if (event.end) {
        switch (precision) {
            case 'minutes':
                span = dateFns.differenceInSeconds(event.end, begin);
                break;
            default:
                span = dateFns.differenceInDays(dateFns.addDays(event.end, 1), begin) * SECONDS_IN_DAY;
                break;
        }
    }
    var /** @type {?} */ offsetSeconds = offset * SECONDS_IN_DAY;
    var /** @type {?} */ totalLength = offsetSeconds + span;
    // the best way to detect if an event is outside the week-view
    // is to check if the total span beginning (from startOfWeekDay or event start) exceeds 7days
    if (totalLength > SECONDS_IN_WEEK) {
        span = SECONDS_IN_WEEK - offsetSeconds;
    }
    span -= getExcludedSeconds({
        startDate: begin,
        seconds: span,
        excluded: excluded,
        precision: precision
    });
    return span / SECONDS_IN_DAY;
}
/**
 * @param {?} __0
 * @return {?}
 */
function getWeekViewEventOffset(_b) {
    var event = _b.event, startOfWeekDate = _b.startOfWeek, _c = _b.excluded, excluded = _c === void 0 ? [] : _c, _d = _b.precision, precision = _d === void 0 ? 'days' : _d;
    if (event.start < startOfWeekDate) {
        return 0;
    }
    var /** @type {?} */ offset = 0;
    switch (precision) {
        case 'days':
            offset =
                dateFns.differenceInDays(dateFns.startOfDay(event.start), startOfWeekDate) *
                    SECONDS_IN_DAY;
            break;
        case 'minutes':
            offset = dateFns.differenceInSeconds(event.start, startOfWeekDate);
            break;
    }
    offset -= getExcludedSeconds({
        startDate: startOfWeekDate,
        seconds: offset,
        excluded: excluded,
        precision: precision
    });
    return offset / SECONDS_IN_DAY;
}
/**
 * @param {?} __0
 * @return {?}
 */
function getExcludedSeconds(_b) {
    var startDate = _b.startDate, seconds = _b.seconds, excluded = _b.excluded, _c = _b.precision, precision = _c === void 0 ? 'days' : _c;
    if (excluded.length < 1) {
        return 0;
    }
    var /** @type {?} */ endDate = dateFns.addSeconds(startDate, seconds - 1);
    var /** @type {?} */ dayStart = dateFns.getDay(startDate);
    var /** @type {?} */ dayEnd = dateFns.getDay(dateFns.addSeconds(endDate, 0));
    var /** @type {?} */ result = 0; // Calculated in seconds
    var /** @type {?} */ current = startDate;
    var _loop_5 = function () {
        var /** @type {?} */ day = dateFns.getDay(current);
        if (excluded.some(function (excludedDay) { return excludedDay === day; })) {
            result += calculateExcludedSeconds({
                dayStart: dayStart,
                dayEnd: dayEnd,
                day: day,
                precision: precision,
                startDate: startDate,
                endDate: endDate
            });
        }
        current = dateFns.addDays(current, 1);
    };
    while (current < endDate) {
        _loop_5();
    }
    return result;
}
/**
 * @param {?} __0
 * @return {?}
 */
function calculateExcludedSeconds(_b) {
    var precision = _b.precision, day = _b.day, dayStart = _b.dayStart, dayEnd = _b.dayEnd, startDate = _b.startDate, endDate = _b.endDate;
    if (precision === 'minutes') {
        if (day === dayStart) {
            return dateFns.differenceInSeconds(dateFns.endOfDay(startDate), startDate) + 1;
        }
        else if (day === dayEnd) {
            return dateFns.differenceInSeconds(endDate, dateFns.startOfDay(endDate)) + 1;
        }
    }
    return SECONDS_IN_DAY;
}
var HOURS_IN_DAY$3 = 24;
/**
 * @param {?} __0
 * @return {?}
 */
function getScheduleView(_b) {
    var _c = _b.events, events = _c === void 0 ? [] : _c, viewDate = _b.viewDate;
    var /** @type {?} */ previousDate = viewDate;
    var /** @type {?} */ days = [];
    for (var /** @type {?} */ day = 0; day < 7; day++) {
        var /** @type {?} */ startDay = dateFns.startOfDay(previousDate);
        var /** @type {?} */ endDay = dateFns.endOfDay(previousDate);
        var /** @type {?} */ eventsInDay = getEventsInPeriod({
            events: events,
            periodStart: startDay,
            periodEnd: endDay
        });
        if (eventsInDay.length > 0) {
            days.push({
                date: previousDate,
                events: eventsInDay
            });
        }
        previousDate = dateFns.startOfDay(dateFns.addHours(previousDate, HOURS_IN_DAY$3 + 1));
    }
    return days;
}
var CalendarUtilsService = (function () {
    function CalendarUtilsService() {
    }
    /**
     * @param {?} args
     * @return {?}
     */
    CalendarUtilsService.prototype.getScheduleView = function (args) {
        return getScheduleView(args);
    };
    /**
     * @param {?} args
     * @return {?}
     */
    CalendarUtilsService.prototype.getWeekView = function (args) {
        return getWeekView(args);
    };
    /**
     * @param {?} args
     * @return {?}
     */
    CalendarUtilsService.prototype.getMonthViewGrid = function (args) {
        return getMonthViewGrid(args);
    };
    /**
     * @param {?} args
     * @return {?}
     */
    CalendarUtilsService.prototype.getWeekViewHeader = function (args) {
        return getWeekViewHeader(args);
    };
    /**
     * @param {?} args
     * @return {?}
     */
    CalendarUtilsService.prototype.getDayView = function (args) {
        return getDayView(args);
    };
    /**
     * @param {?} args
     * @return {?}
     */
    CalendarUtilsService.prototype.getDayViewHourGrid = function (args) {
        return getDayViewHourGrid(args);
    };
    return CalendarUtilsService;
}());
CalendarUtilsService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
CalendarUtilsService.ctorParameters = function () { return []; };
var validateEvents = function (events) {
    var /** @type {?} */ warn = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return console.warn.apply(console, ['angular-calendar'].concat(args));
    };
    return validateEventsWithoutLog(events, warn);
};
/**
 * @param {?} outer
 * @param {?} inner
 * @return {?}
 */
function isInside(outer, inner) {
    return (outer.left <= inner.left &&
        inner.left <= outer.right &&
        outer.left <= inner.right &&
        inner.right <= outer.right &&
        outer.top <= inner.top &&
        inner.top <= outer.bottom &&
        outer.top <= inner.bottom &&
        inner.bottom <= outer.bottom);
}
/**
 * @param {?} events
 * @param {?} log
 * @return {?}
 */
function validateEventsWithoutLog(events, log) {
    var /** @type {?} */ isValid = true;
    /**
     * @param {?} msg
     * @param {?} event
     * @return {?}
     */
    function isError(msg, event) {
        log(msg, event);
        isValid = false;
    }
    if (!Array.isArray(events)) {
        log('Events must be an array', events);
        return false;
    }
    events.forEach(function (event) {
        if (!event.start) {
            isError('Event is missing the `start` property', event);
        }
        else if (!dateFns.isDate(event.start)) {
            isError('Event `start` property should be a javascript date object. Do `new Date(event.start)` to fix it.', event);
        }
        if (event.end) {
            if (!dateFns.isDate(event.end)) {
                isError('Event `end` property should be a javascript date object. Do `new Date(event.end)` to fix it.', event);
            }
            if (event.start > event.end) {
                isError('Event `start` property occurs after the `end`', event);
            }
        }
    });
    return isValid;
}
var CalendarDragHelper = (function () {
    /**
     * @param {?} dragContainerElement
     * @param {?} draggableElement
     */
    function CalendarDragHelper(dragContainerElement, draggableElement) {
        this.dragContainerElement = dragContainerElement;
        this.startPosition = draggableElement.getBoundingClientRect();
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    CalendarDragHelper.prototype.validateDrag = function (_b) {
        var x = _b.x, y = _b.y;
        var /** @type {?} */ newRect = Object.assign({}, this.startPosition, {
            left: this.startPosition.left + x,
            right: this.startPosition.right + x,
            top: this.startPosition.top + y,
            bottom: this.startPosition.bottom + y
        });
        return isInside(this.dragContainerElement.getBoundingClientRect(), newRect);
    };
    return CalendarDragHelper;
}());
var CalendarResizeHelper = (function () {
    /**
     * @param {?} resizeContainerElement
     * @param {?=} minWidth
     */
    function CalendarResizeHelper(resizeContainerElement, minWidth) {
        this.resizeContainerElement = resizeContainerElement;
        this.minWidth = minWidth;
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    CalendarResizeHelper.prototype.validateResize = function (_b) {
        var rectangle = _b.rectangle;
        if (this.minWidth && rectangle.width < this.minWidth) {
            return false;
        }
        return isInside(this.resizeContainerElement.getBoundingClientRect(), rectangle);
    };
    return CalendarResizeHelper;
}());
/**
 * @hidden
 */
var MINUTES_IN_HOUR = 60;
var DayViewComponent = (function () {
    /**
     * @param {?} cdr
     * @param {?} utils
     * @param {?} locale
     */
    function DayViewComponent(cdr, utils, locale) {
        this.cdr = cdr;
        this.utils = utils;
        /**
         * An array of events to display on view
         */
        this.events = [];
        /**
         * The number of segments in an hour. Must be <= 6
         */
        this.hourSegments = 2;
        /**
         * The height in pixels of each hour segment
         */
        this.hourSegmentHeight = 30;
        /**
         * The day start hours in 24 hour time. Must be 0-23
         */
        this.dayStartHour = 0;
        /**
         * The day start minutes. Must be 0-59
         */
        this.dayStartMinute = 0;
        /**
         * The day end hours in 24 hour time. Must be 0-23
         */
        this.dayEndHour = 23;
        /**
         * The day end minutes. Must be 0-59
         */
        this.dayEndMinute = 59;
        /**
         * The width in pixels of each event on the view
         */
        this.eventWidth = 150;
        /**
         * The grid size to snap resizing and dragging of events to
         */
        this.eventSnapSize = this.hourSegmentHeight;
        /**
         * Called when an event title is clicked
         */
        this.eventClicked = new core.EventEmitter();
        /**
         * Called when an hour segment is clicked
         */
        this.hourSegmentClicked = new core.EventEmitter();
        /**
         * Called when an event is resized or dragged and dropped
         */
        this.eventTimesChanged = new core.EventEmitter();
        /**
         * An output that will be called before the view is rendered for the current day.
         * If you add the `cssClass` property to a segment it will add that class to the hour segment in the template
         */
        this.beforeViewRender = new core.EventEmitter();
        /**
         * @hidden
         */
        this.hours = [];
        /**
         * @hidden
         */
        this.width = 0;
        /**
         * @hidden
         */
        this.currentResizes = new Map();
        this.locale = locale;
    }
    /**
     * @return {?}
     */
    DayViewComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.refresh) {
            this.refreshSubscription = this.refresh.subscribe(function () {
                _this.refreshAll();
                _this.cdr.markForCheck();
            });
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    DayViewComponent.prototype.ngOnChanges = function (changes) {
        if (changes.viewDate ||
            changes.dayStartHour ||
            changes.dayStartMinute ||
            changes.dayEndHour ||
            changes.dayEndMinute) {
            this.refreshHourGrid();
        }
        if (changes.events) {
            validateEvents(this.events);
        }
        if (changes.viewDate ||
            changes.events ||
            changes.dayStartHour ||
            changes.dayStartMinute ||
            changes.dayEndHour ||
            changes.dayEndMinute ||
            changes.eventWidth) {
            this.refreshView();
        }
    };
    /**
     * @return {?}
     */
    DayViewComponent.prototype.ngOnDestroy = function () {
        if (this.refreshSubscription) {
            this.refreshSubscription.unsubscribe();
        }
    };
    /**
     * @param {?} dropEvent
     * @param {?} segment
     * @return {?}
     */
    DayViewComponent.prototype.eventDropped = function (dropEvent, segment) {
        if (dropEvent.dropData && dropEvent.dropData.event) {
            this.eventTimesChanged.emit({
                event: dropEvent.dropData.event,
                newStart: segment.date
            });
        }
    };
    /**
     * @param {?} event
     * @param {?} resizeEvent
     * @param {?} dayViewContainer
     * @return {?}
     */
    DayViewComponent.prototype.resizeStarted = function (event, resizeEvent, dayViewContainer) {
        this.currentResizes.set(event, {
            originalTop: event.top,
            originalHeight: event.height,
            edge: typeof resizeEvent.edges.top !== 'undefined' ? 'top' : 'bottom'
        });
        var /** @type {?} */ resizeHelper = new CalendarResizeHelper(dayViewContainer);
        this.validateResize = function (_b) {
            var rectangle = _b.rectangle;
            return resizeHelper.validateResize({ rectangle: rectangle });
        };
        this.cdr.markForCheck();
    };
    /**
     * @param {?} event
     * @param {?} resizeEvent
     * @return {?}
     */
    DayViewComponent.prototype.resizing = function (event, resizeEvent) {
        var /** @type {?} */ currentResize = this.currentResizes.get(event);
        if (resizeEvent.edges.top) {
            event.top = currentResize.originalTop + +resizeEvent.edges.top;
            event.height = currentResize.originalHeight - +resizeEvent.edges.top;
        }
        else if (resizeEvent.edges.bottom) {
            event.height = currentResize.originalHeight + +resizeEvent.edges.bottom;
        }
    };
    /**
     * @param {?} dayEvent
     * @return {?}
     */
    DayViewComponent.prototype.resizeEnded = function (dayEvent) {
        var /** @type {?} */ currentResize = this.currentResizes.get(dayEvent);
        var /** @type {?} */ pixelsMoved;
        if (currentResize.edge === 'top') {
            pixelsMoved = dayEvent.top - currentResize.originalTop;
        }
        else {
            pixelsMoved = dayEvent.height - currentResize.originalHeight;
        }
        dayEvent.top = currentResize.originalTop;
        dayEvent.height = currentResize.originalHeight;
        var /** @type {?} */ pixelAmountInMinutes = MINUTES_IN_HOUR / (this.hourSegments * this.hourSegmentHeight);
        var /** @type {?} */ minutesMoved = pixelsMoved * pixelAmountInMinutes;
        var /** @type {?} */ newStart = dayEvent.event.start;
        var /** @type {?} */ newEnd = dayEvent.event.end;
        if (currentResize.edge === 'top') {
            newStart = dateFns.addMinutes(newStart, minutesMoved);
        }
        else if (newEnd) {
            newEnd = dateFns.addMinutes(newEnd, minutesMoved);
        }
        this.eventTimesChanged.emit({ newStart: newStart, newEnd: newEnd, event: dayEvent.event });
        this.currentResizes.delete(dayEvent);
    };
    /**
     * @param {?} event
     * @param {?} dayViewContainer
     * @return {?}
     */
    DayViewComponent.prototype.dragStart = function (event, dayViewContainer) {
        var _this = this;
        var /** @type {?} */ dragHelper = new CalendarDragHelper(dayViewContainer, event);
        this.validateDrag = function (_b) {
            var x = _b.x, y = _b.y;
            return _this.currentResizes.size === 0 && dragHelper.validateDrag({ x: x, y: y });
        };
        this.cdr.markForCheck();
    };
    /**
     * @param {?} dayEvent
     * @param {?} draggedInPixels
     * @return {?}
     */
    DayViewComponent.prototype.eventDragged = function (dayEvent, draggedInPixels) {
        var /** @type {?} */ pixelAmountInMinutes = MINUTES_IN_HOUR / (this.hourSegments * this.hourSegmentHeight);
        var /** @type {?} */ minutesMoved = draggedInPixels * pixelAmountInMinutes;
        var /** @type {?} */ newStart = dateFns.addMinutes(dayEvent.event.start, minutesMoved);
        // possible issue
        var /** @type {?} */ newEnd = new Date();
        if (dayEvent.event.end) {
            newEnd = dateFns.addMinutes(dayEvent.event.end, minutesMoved);
        }
        this.eventTimesChanged.emit({ newStart: newStart, newEnd: newEnd, event: dayEvent.event });
    };
    /**
     * @return {?}
     */
    DayViewComponent.prototype.refreshHourGrid = function () {
        this.hours = this.utils.getDayViewHourGrid({
            viewDate: this.viewDate,
            hourSegments: this.hourSegments,
            dayStart: {
                hour: this.dayStartHour,
                minute: this.dayStartMinute
            },
            dayEnd: {
                hour: this.dayEndHour,
                minute: this.dayEndMinute
            }
        });
        this.beforeViewRender.emit({
            body: this.hours
        });
    };
    /**
     * @return {?}
     */
    DayViewComponent.prototype.refreshView = function () {
        this.view = this.utils.getDayView({
            events: this.events,
            viewDate: this.viewDate,
            hourSegments: this.hourSegments,
            dayStart: {
                hour: this.dayStartHour,
                minute: this.dayStartMinute
            },
            dayEnd: {
                hour: this.dayEndHour,
                minute: this.dayEndMinute
            },
            eventWidth: this.eventWidth,
            segmentHeight: this.hourSegmentHeight
        });
    };
    /**
     * @return {?}
     */
    DayViewComponent.prototype.refreshAll = function () {
        this.refreshHourGrid();
        this.refreshView();
    };
    return DayViewComponent;
}());
DayViewComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-day-view',
                template: "\n    <div class=\"cal-day-view\" #dayViewContainer>\n      <calendar-day-view-all-day-event\n        *ngFor=\"let event of view.allDayEvents\"\n        [event]=\"event\"\n        (eventClicked)=\"eventClicked.emit({event: event})\">\n      </calendar-day-view-all-day-event>\n      <div class=\"cal-hour-rows\">\n        <div class=\"cal-events\">\n          <div\n            #event\n            *ngFor=\"let dayEvent of view?.events\"\n            class=\"cal-event-container\"\n            [class.cal-draggable]=\"dayEvent.event.draggable\"\n            [class.cal-starts-within-day]=\"!dayEvent.startsBeforeDay\"\n            [class.cal-ends-within-day]=\"!dayEvent.endsAfterDay\"\n            [ngClass]=\"dayEvent.event.cssClass\"\n            mwlResizable\n            [resizeEdges]=\"{top: dayEvent.event?.resizable?.beforeStart, bottom: dayEvent.event?.resizable?.afterEnd}\"\n            [resizeSnapGrid]=\"{top: eventSnapSize, bottom: eventSnapSize}\"\n            [validateResize]=\"validateResize\"\n            (resizeStart)=\"resizeStarted(dayEvent, $event, dayViewContainer)\"\n            (resizing)=\"resizing(dayEvent, $event)\"\n            (resizeEnd)=\"resizeEnded(dayEvent)\"\n            mwlDraggable\n            [dragAxis]=\"{x: false, y: dayEvent.event.draggable && currentResizes.size === 0}\"\n            [dragSnapGrid]=\"{y: eventSnapSize}\"\n            [validateDrag]=\"validateDrag\"\n            (dragStart)=\"dragStart(event, dayViewContainer)\"\n            (dragEnd)=\"eventDragged(dayEvent, $event.y)\"\n            [style.marginTop.px]=\"dayEvent.top\"\n            [style.height.px]=\"dayEvent.height\"\n            [style.marginLeft.px]=\"dayEvent.left + 70\"\n            [style.width.px]=\"dayEvent.width - 1\">\n            <calendar-day-view-event\n              [dayEvent]=\"dayEvent\"\n              (eventClicked)=\"eventClicked.emit({event: dayEvent.event})\">\n            </calendar-day-view-event>\n          </div>\n        </div>\n        <div class=\"cal-hour\" *ngFor=\"let hour of hours\" [style.minWidth.px]=\"view?.width + 70\">\n          <calendar-day-view-hour-segment\n            *ngFor=\"let segment of hour.segments\"\n            [style.height.px]=\"hourSegmentHeight\"\n            [segment]=\"segment\"\n            [segmentHeight]=\"hourSegmentHeight\"\n            [locale]=\"locale\"\n            (click)=\"hourSegmentClicked.emit({date: segment.date})\">\n          </calendar-day-view-hour-segment>\n        </div>\n      </div>\n    </div>\n  ",
                styles: ["\n    .cal-day-view .cal-hour-rows {\n      width: 100%;\n      border: solid 1px #e1e1e1;\n      overflow-x: scroll;\n      position: relative;\n    }\n  \n    .cal-day-view .cal-hour {\n      background-color: white;\n    }\n  \n    .cal-event-container {\n      position: absolute;\n    }\n  \n  \n  "]
            },] },
];
/**
 * @nocollapse
 */
DayViewComponent.ctorParameters = function () { return [
    { type: core.ChangeDetectorRef, },
    { type: CalendarUtilsService, },
    { type: undefined, decorators: [{ type: core.Inject, args: [core.LOCALE_ID,] },] },
]; };
DayViewComponent.propDecorators = {
    'viewDate': [{ type: core.Input },],
    'events': [{ type: core.Input },],
    'hourSegments': [{ type: core.Input },],
    'hourSegmentHeight': [{ type: core.Input },],
    'dayStartHour': [{ type: core.Input },],
    'dayStartMinute': [{ type: core.Input },],
    'dayEndHour': [{ type: core.Input },],
    'dayEndMinute': [{ type: core.Input },],
    'eventWidth': [{ type: core.Input },],
    'refresh': [{ type: core.Input },],
    'locale': [{ type: core.Input },],
    'eventSnapSize': [{ type: core.Input },],
    'eventClicked': [{ type: core.Output },],
    'hourSegmentClicked': [{ type: core.Output },],
    'eventTimesChanged': [{ type: core.Output },],
    'beforeViewRender': [{ type: core.Output },],
};
var DayViewAllDayEventComponent = (function () {
    function DayViewAllDayEventComponent() {
        this.eventClicked = new core.EventEmitter();
    }
    return DayViewAllDayEventComponent;
}());
DayViewAllDayEventComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-day-view-all-day-event',
                template: "\n    <ng-template\n    #defaultTemplate\n    let-event=\"event\"\n    let-eventClicked=\"eventClicked\">\n    <div\n      class=\"cal-all-day-event\"\n      [style.backgroundColor]=\"event.color ? event.color.primary : event.calendar.color\">\n      <calendar-event-action [event]=\"event\"></calendar-event-action>\n      <calendar-event-title\n        [event]=\"event\"\n        view=\"day\"\n        (mwlClick)=\"eventClicked.emit()\">\n      </calendar-event-title>\n    </div>\n    </ng-template>\n    <ng-template\n    [ngTemplateOutlet]=\"defaultTemplate\"\n    [ngTemplateOutletContext]=\"{\n      event: event,\n      eventClicked: eventClicked\n    }\">\n    </ng-template>\n  ",
                styles: ["\n    .cal-all-day-event{\n        margin-bottom: 2px; \n        font-size: 13px;\n        padding: 5px;\n    }\n  "]
            },] },
];
/**
 * @nocollapse
 */
DayViewAllDayEventComponent.ctorParameters = function () { return []; };
DayViewAllDayEventComponent.propDecorators = {
    'event': [{ type: core.Input },],
    'customTemplate': [{ type: core.Input },],
    'eventTitleTemplate': [{ type: core.Input },],
    'eventClicked': [{ type: core.Output },],
};
var DayViewEventComponent = (function () {
    function DayViewEventComponent() {
        this.eventClicked = new core.EventEmitter();
    }
    return DayViewEventComponent;
}());
DayViewEventComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-day-view-event',
                template: "\n    <ng-template\n    #defaultTemplate\n    let-dayEvent=\"dayEvent\"\n    let-eventClicked=\"eventClicked\">\n    <div\n      class=\"cal-event\"\n      [style.backgroundColor]=\"dayEvent.event.color ? dayEvent.event.color.primary : dayEvent.event.calendar.color\">\n      <calendar-event-action [event]=\"dayEvent.event\"></calendar-event-action>\n      <calendar-event-title\n        [event]=\"dayEvent.event\"\n        view=\"day\"\n        (click)=\"eventClicked.emit()\">\n      </calendar-event-title>\n    </div>\n    </ng-template>\n    <ng-template\n    [ngTemplateOutlet]=\"defaultTemplate\"\n    [ngTemplateOutletContext]=\"{\n      dayEvent: dayEvent,\n      eventClicked: eventClicked\n    }\">\n    </ng-template>\n  ",
                styles: ["\n    .cal-event{\n        height: 100%;\n        font-size: 12px;\n        padding-left: 5px;\n        color: white !important;\n        font-size: 12px;\n    }\n    .cal-event a {\n        color: white !important;\n        font-size: 12px; \n    }\n  "]
            },] },
];
/**
 * @nocollapse
 */
DayViewEventComponent.ctorParameters = function () { return []; };
DayViewEventComponent.propDecorators = {
    'dayEvent': [{ type: core.Input },],
    'tooltipPlacement': [{ type: core.Input },],
    'tooltipAppendToBody': [{ type: core.Input },],
    'customTemplate': [{ type: core.Input },],
    'eventTitleTemplate': [{ type: core.Input },],
    'tooltipTemplate': [{ type: core.Input },],
    'eventClicked': [{ type: core.Output },],
};
var DayViewHourSegmentComponent = (function () {
    function DayViewHourSegmentComponent() {
    }
    return DayViewHourSegmentComponent;
}());
DayViewHourSegmentComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-day-view-hour-segment',
                template: "\n    <ng-template\n    #defaultTemplate\n    let-segment=\"segment\"\n    let-locale=\"locale\">\n    <div\n      class=\"cal-hour-segment\"\n      [style.height.px]=\"segmentHeight\"\n      [class.cal-hour-start]=\"segment.isStart\"\n      [class.cal-after-hour-start]=\"!segment.isStart\"\n      [ngClass]=\"segment.cssClass\">\n      <div class=\"cal-time\">\n        {{ segment.date | date: 'h:mm a' }}\n      </div>\n    </div>\n    </ng-template>\n    <ng-template\n    [ngTemplateOutlet]=\"defaultTemplate\"\n    [ngTemplateOutletContext]=\"{\n      segment: segment,\n      locale: locale\n    }\">\n    </ng-template>\n  ",
                styles: ["\n    .cal-hour-segment{\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        border-bottom: 1px solid #e1e1e1;\n        border-right: 1px solid #e1e1e1;\n        border-left: 1px solid #e1e1e1;\n    }\n    .cal-hour-segment.cal-after-hour-start .cal-time {\n        color: transparent;\n        border-bottom: 1px solid #e1e1e1;\n\n    }\n    .cal-hour-segment .cal-time {    \n        height: 30px;\n        font-size: 12px;\n        padding-left: 15px;\n        border-right: 1px solid #e1e1e1;\n    }\n\n\n    .cal-hour-segment .cal-hour-segment-header:not(:last-child) {\n        border-right: 1px solid #e1e1e1;\n      }\n    .cal-hour-segment .cal-time {\n        position: absolute;\n        width: 70px;\n        left: 0;\n    }\n    .cal-hour-segment .cal-hour-segment-header {\n        -webkit-box-flex: 1;\n            -ms-flex: 1;\n                flex: 1;\n    } \n    .cal-hour-segment:hover {\n        background-color: transparent;\n    }\n\n    .cal-hour-segment.cal-hour-start {\n        border-bottom: none;\n    }\n  "]
            },] },
];
/**
 * @nocollapse
 */
DayViewHourSegmentComponent.ctorParameters = function () { return []; };
DayViewHourSegmentComponent.propDecorators = {
    'segment': [{ type: core.Input },],
    'segmentHeight': [{ type: core.Input },],
    'locale': [{ type: core.Input },],
    'customTemplate': [{ type: core.Input },],
};
var EventActionComponent = (function () {
    function EventActionComponent() {
    }
    /**
     * @return {?}
     */
    EventActionComponent.prototype.ngOnInit = function () {
    };
    return EventActionComponent;
}());
EventActionComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-event-action',
                template: "\n    <span *ngIf=\"event.actions\" class=\"cal-event-actions\">\n      <a\n        class=\"cal-event-action\"\n        href=\"javascript:;\"\n        *ngFor=\"let action of event.actions\"\n        (mwlClick)=\"action.onClick({event: event})\"\n        [ngClass]=\"action.cssClass\"\n        [innerHtml]=\"action.label\">\n      </a>\n    </span>\n  ",
                styles: ["\n\n  "]
            },] },
];
/**
 * @nocollapse
 */
EventActionComponent.ctorParameters = function () { return []; };
EventActionComponent.propDecorators = {
    'event': [{ type: core.Input },],
};
var EventTitleComponent = (function () {
    function EventTitleComponent() {
    }
    /**
     * @return {?}
     */
    EventTitleComponent.prototype.ngOnInit = function () {
    };
    return EventTitleComponent;
}());
EventTitleComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-event-title',
                template: "\n    <ng-template\n    #defaultTemplate\n    let-event=\"event\"\n    let-view=\"view\">\n    <a\n      class=\"cal-event-title\"\n      href=\"javascript:;\"\n      [innerHTML]=\"event.title\">\n    </a>\n    </ng-template>\n    <ng-template\n    [ngTemplateOutlet]=\"defaultTemplate\"\n    [ngTemplateOutletContext]=\"{\n      event: event,\n      view: view\n    }\">\n    </ng-template>\n  ",
                styles: ["\n    .cal-event-title{\n        font-size: 12px;\n        color: white;\n    }\n  "]
            },] },
];
/**
 * @nocollapse
 */
EventTitleComponent.ctorParameters = function () { return []; };
EventTitleComponent.propDecorators = {
    'event': [{ type: core.Input },],
    'customTemplate': [{ type: core.Input },],
    'view': [{ type: core.Input },],
};
var DayModule = (function () {
    function DayModule() {
    }
    return DayModule;
}());
DayModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    ResizableModule,
                    DragAndDropModule
                ],
                declarations: [
                    DayViewComponent,
                    DayViewAllDayEventComponent,
                    DayViewEventComponent,
                    DayViewHourSegmentComponent,
                    EventActionComponent,
                    EventTitleComponent
                ],
                exports: [
                    DayViewComponent,
                ]
            },] },
];
/**
 * @nocollapse
 */
DayModule.ctorParameters = function () { return []; };
var MonthViewComponent = (function () {
    /**
     * @hidden
     * @param {?} cdr
     * @param {?} utils
     * @param {?} locale
     */
    function MonthViewComponent(cdr, utils, locale) {
        this.cdr = cdr;
        this.utils = utils;
        /**
         * An array of events to display on view.
         */
        this.events = [];
        /**
         * An array of day indexes (0 = sunday, 1 = monday etc) that will be hidden on the view
         */
        this.excludeDays = [];
        /**
         * Whether the events list for the day of the `viewDate` option is visible or not
         */
        this.activeDayIsOpen = false;
        /**
         * An output that will be called before the view is rendered for the current month.
         * If you add the `cssClass` property to a day in the body it will add that class to the cell element in the template
         */
        this.beforeViewRender = new core.EventEmitter();
        /**
         * Called when the day cell is clicked
         */
        this.dayClicked = new core.EventEmitter();
        /**
         * Called when the event title is clicked
         */
        this.eventClicked = new core.EventEmitter();
        /**
         * Called when an event is dragged and dropped
         */
        this.eventTimesChanged = new core.EventEmitter();
        this.locale = locale;
    }
    /**
     * @return {?}
     */
    MonthViewComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.refresh) {
            this.refreshSubscription = this.refresh.subscribe(function () {
                _this.refreshAll();
                _this.cdr.markForCheck();
            });
        }
    };
    /**
     * @hidden
     * @param {?} changes
     * @return {?}
     */
    MonthViewComponent.prototype.ngOnChanges = function (changes) {
        if (changes.viewDate || changes.excludeDays || changes.weekendDays) {
            this.refreshHeader();
        }
        if (changes.events) {
            validateEvents(this.events);
        }
        if (changes.viewDate ||
            changes.events ||
            changes.excludeDays ||
            changes.weekendDays) {
            this.refreshBody();
        }
        if (changes.activeDayIsOpen ||
            changes.viewDate ||
            changes.events ||
            changes.excludeDays) {
            this.checkActiveDayIsOpen();
        }
    };
    /**
     * @hidden
     * @return {?}
     */
    MonthViewComponent.prototype.ngOnDestroy = function () {
        if (this.refreshSubscription) {
            this.refreshSubscription.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    MonthViewComponent.prototype.refreshHeader = function () {
        this.columnHeaders = this.utils.getWeekViewHeader({
            viewDate: this.viewDate,
            weekStartsOn: this.weekStartsOn,
            excluded: this.excludeDays,
            weekendDays: this.weekendDays
        });
        this.emitBeforeViewRender();
    };
    /**
     * @return {?}
     */
    MonthViewComponent.prototype.refreshBody = function () {
        this.view = this.utils.getMonthViewGrid({
            events: this.events,
            viewDate: this.viewDate,
            weekStartsOn: this.weekStartsOn,
            excluded: this.excludeDays,
            weekendDays: this.weekendDays
        });
        this.emitBeforeViewRender();
    };
    /**
     * @return {?}
     */
    MonthViewComponent.prototype.emitBeforeViewRender = function () {
        if (this.columnHeaders && this.view) {
            this.beforeViewRender.emit({
                header: this.columnHeaders,
                body: this.view.days
            });
        }
    };
    /**
     * @return {?}
     */
    MonthViewComponent.prototype.checkActiveDayIsOpen = function () {
        var _this = this;
        if (this.activeDayIsOpen === true) {
            this.openDay = this.view.days.find(function (day) { return dateFns.isSameDay(day.date, _this.viewDate); });
            var /** @type {?} */ index = this.view.days.indexOf(this.openDay);
            this.openRowIndex =
                Math.floor(index / this.view.totalDaysVisibleInWeek) *
                    this.view.totalDaysVisibleInWeek;
        }
        else {
            this.openRowIndex = null;
            this.openDay = null;
        }
    };
    /**
     * @return {?}
     */
    MonthViewComponent.prototype.refreshAll = function () {
        this.columnHeaders = null;
        this.view = null;
        this.refreshHeader();
        this.refreshBody();
        this.checkActiveDayIsOpen();
    };
    return MonthViewComponent;
}());
MonthViewComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-month-view',
                template: "\n    <div class=\"cal-month-view\">\n        <calendar-month-view-header\n          [days]=\"columnHeaders\"\n          [locale]=\"locale\">\n        </calendar-month-view-header>\n        <div class=\"cal-days\">\n            <div class=\"cal-row\" *ngFor=\"let rowIndex of view.rowOffsets; let index = index\">\n              <div *ngIf=\"rowIndex\" class=\"cal-cell-row\">\n                  <calendar-month-cell\n                  class=\"cal-day-cell\"\n                  *ngFor=\"let day of rowIndex.days\"\n                  [class.cal-drag-over]=\"day.dragOver\"\n                  [ngClass]=\"{'isToday': day.isToday }\"\n                  [day]=\"day\"\n                  [openDay]=\"openDay\"\n                  [locale]=\"locale\"\n                  (click)=\"dayClicked.emit({day:day})\"\n                  mwlDroppable\n                  (dragEnter)=\"day.dragOver = true\"\n                  (dragLeave)=\"day.dragOver = false\">\n                </calendar-month-cell>\n                <div *ngFor=\"let event of rowIndex.events\">\n                    <div\n                    *ngIf=\"!event.hidden && event.event.allDay\"\n                    class=\"month-event\"\n                    [style.height.px]=\"20\"\n                    [style.top.px]=\"event.top\"\n                    [style.backgroundColor]=\"event.event.color ? event.event.color.primary : event.event.calendar.color\"\n                    [style.left]=\"event.left + '%'\"\n                    [style.width]=\"event.width + '%'\"\n                    (click)=\"eventClicked.emit({event:event.event})\"\n                    >\n                    <div class=\"month-event-title\">\n                        {{ event.event.start | date : 'hh:mm a'}} {{ event.event.title }}\n                    </div>\n                    </div>\n                </div>\n              </div>\n            </div>\n          </div>\n    </div>\n  \n  ",
                styles: ["\n    .cal-month-view {\n      overflow: hidden;\n      background-color: white; }\n\n    .cal-days {\n      border: 1px solid #E0E0E0;\n      border-bottom: 0;\n      position: relative; }\n\n    .month-events-of-week {\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1; }\n\n    .cal-row {\n      position: relative; }\n\n    .month-event {\n      position: absolute;\n      color: white;\n      padding-left: 5px;\n      padding-right: 5px;\n      font-size: 12px;\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-box-align: center;\n          -ms-flex-align: center;\n              align-items: center;\n      cursor: pointer;\n      overflow: hidden; }\n\n    .month-event-title {\n      white-space: nowrap;\n      text-overflow: ellipsis;\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1;\n      overflow: hidden; }\n\n    .non-all-day-event {\n      cursor: pointer;\n      position: absolute;\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      font-size: 12px;\n      -webkit-box-align: center;\n          -ms-flex-align: center;\n              align-items: center;\n      width: 14.28571%;\n      overflow: hidden; }\n\n    .non-all-day-event-title {\n      white-space: nowrap;\n      text-overflow: ellipsis;\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1;\n      overflow: hidden; }\n\n    .non-all-day-event-bg {\n      height: 10px;\n      width: 10px;\n      border-radius: 50%;\n      margin-left: 5px;\n      margin-right: 5px; }\n\n    .cal-cell-row:hover {\n      background-color: #fafafa; }\n\n    .cal-cell-row .cal-cell:hover,\n    .cal-cell.cal-has-events.cal-open {\n      background-color: #ededed; }\n\n    .cal-cell-row {\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex; }\n\n    .cal-cell {\n      float: left;\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1;\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-box-orient: vertical;\n      -webkit-box-direction: normal;\n          -ms-flex-direction: column;\n              flex-direction: column;\n      -webkit-box-align: stretch;\n          -ms-flex-align: stretch;\n              align-items: stretch; }\n\n    .cal-day-cell {\n      height: 100px;\n      width: 14.28571%;\n      overflow: hidden;\n      position: relative; }\n\n    .cal-day-cell:not(:last-child) {\n      border-right: 1px solid #E0E0E0; }\n\n    .cal-weekend:not(:first-child) {\n      border-right: none !important; }\n\n    .cal-days .cal-cell-row {\n      border-bottom: 1px solid #E0E0E0; }\n\n    .isToday {\n      background-color: #fafafa; }\n  "]
            },] },
];
/**
 * @nocollapse
 */
MonthViewComponent.ctorParameters = function () { return [
    { type: core.ChangeDetectorRef, },
    { type: CalendarUtilsService, },
    { type: undefined, decorators: [{ type: core.Inject, args: [core.LOCALE_ID,] },] },
]; };
MonthViewComponent.propDecorators = {
    'viewDate': [{ type: core.Input },],
    'events': [{ type: core.Input },],
    'excludeDays': [{ type: core.Input },],
    'activeDayIsOpen': [{ type: core.Input },],
    'refresh': [{ type: core.Input },],
    'locale': [{ type: core.Input },],
    'weekStartsOn': [{ type: core.Input },],
    'weekendDays': [{ type: core.Input },],
    'beforeViewRender': [{ type: core.Output },],
    'dayClicked': [{ type: core.Output },],
    'eventClicked': [{ type: core.Output },],
    'eventTimesChanged': [{ type: core.Output },],
};
var MonthCellComponent = (function () {
    function MonthCellComponent() {
        this.highlightDay = new core.EventEmitter();
        this.unhighlightDay = new core.EventEmitter();
        this.eventClicked = new core.EventEmitter();
    }
    /**
     * @hidden
     * @param {?} mouseEvent
     * @param {?} calendarEvent
     * @return {?}
     */
    MonthCellComponent.prototype.onEventClick = function (mouseEvent, calendarEvent) {
        if (mouseEvent.stopPropagation) {
            mouseEvent.stopPropagation();
        }
        this.eventClicked.emit({ event: calendarEvent });
    };
    /**
     * @param {?} end
     * @param {?} start
     * @return {?}
     */
    MonthCellComponent.prototype.isSameDay = function (end, start) {
        var /** @type {?} */ diff = dateFns.isSameDay(end, start);
        var /** @type {?} */ viewEnd = dateFns.endOfWeek(start);
        return diff;
    };
    return MonthCellComponent;
}());
MonthCellComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-month-cell',
                template: "\n    <ng-template\n    #defaultTemplate\n    let-day=\"day\"\n    let-openDay=\"openDay\"\n    let-locale=\"locale\">\n    <div class=\"cal-cell\">\n      <div class=\"cal-cell-top\">\n          <span class=\"cal-day-number\">{{ day.date | date: 'dd' }}</span>\n      </div>\n      <div class=\"cal-cell-day-events\">\n        <div *ngFor=\"let event of day.events\">\n          <div class=\"cal-cell-day-event\"\n          [style.height.px]=\"28\"\n          *ngIf=\"!event.allDay\">\n              <div\n              class=\"cal-cell-day-event-bg\"\n              [style.backgroundColor]=\"event.color ? event.color.primary : event.calendar.color\">\n              </div>\n              <div\n              *ngIf=\"!isSameDay(day.date, event.start)\"\n              class=\"cal-cell-day-event-title\">\n                  {{ day.date | date : 'hh:mm a'}} {{ event.title }}                  \n              </div>\n              <div \n              *ngIf=\"isSameDay(day.date, event.start)\"\n                class=\"cal-cell-day-event-title\">\n                    {{ event.start | date : 'hh:mm a'}} {{ event.title }}    \n              </div>\n          </div>\n        </div>\n      </div>\n      <span class=\"cal-day-badge\" *ngIf=\"day.badgeTotal > 2\">{{ day.badgeTotal - 2 }} more ...</span>\n    </div>\n    </ng-template>\n    <ng-template\n    [ngTemplateOutlet]=\"defaultTemplate\"\n    [ngTemplateOutletContext]=\"{\n      day: day,\n      openDay: openDay,\n      locale: locale,\n      highlightDay: highlightDay,\n      unhighlightDay: unhighlightDay,\n      eventClicked: eventClicked\n    }\">\n    </ng-template>\n  ",
                styles: ["\n    .cal-cell {\n        position: relative;\n        height: 100px;\n    }\n    .cal-cell-top{\n        z-index: 100;\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        -webkit-box-pack: end;\n            -ms-flex-pack: end;\n                justify-content: flex-end;\n        height: 24px;\n        -webkit-box-orient: horizontal;\n        -webkit-box-direction: normal;\n            -ms-flex-direction: row;\n                flex-direction: row;\n    }\n\n    .cal-day-badge {\n        background-color: #e9e9e9;\n        padding: 3px 7px;\n        font-size: 12px;\n        line-height: 1 !important;\n        color: rgb(121, 121, 121);\n        text-align: center;\n        white-space: nowrap;\n        vertical-align: middle;\n        position: absolute;\n        bottom: 0;\n        width: 100%;\n    }\n\n    .cal-day-number {\n        -webkit-box-flex: 1;\n            -ms-flex: 1;\n                flex: 1;\n        font-size: 0.8em;\n        margin-left: 5px;\n        margin-right: 15px;\n        margin-bottom: 10px;\n        color: #555555;\n    }\n    .cal-cell-day-event {\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        font-size: 12px;\n        -webkit-box-align: center;\n            -ms-flex-align: center;\n                align-items: center;\n        cursor: pointer;\n        overflow: hidden;\n    }\n    .cal-cell-day-event-bg{\n        height: 10px;\n        width: 10px;\n        border-radius: 50%;\n        margin-left: 5px;\n        margin-right: 5px;\n    }\n\n    .cal-cell-day-event-title{\n        white-space: nowrap;\n        text-overflow: ellipsis;\n        -webkit-box-flex: 1;\n            -ms-flex: 1;\n                flex: 1;\n        overflow: hidden;\n    }\n  "],
                // tslint:disable-next-line:use-host-property-decorator
                host: {
                    class: 'cal-cell cal-day-cell',
                    '[class.cal-past]': 'day.isPast',
                    '[class.cal-today]': 'day.isToday',
                    '[class.cal-future]': 'day.isFuture',
                    '[class.cal-weekend]': 'day.isWeekend',
                    '[class.cal-in-month]': 'day.inMonth',
                    '[class.cal-out-month]': '!day.inMonth',
                    '[class.cal-has-events]': 'day.events.length > 0',
                    '[class.cal-open]': 'day === openDay',
                    '[style.backgroundColor]': 'day.backgroundColor'
                }
            },] },
];
/**
 * @nocollapse
 */
MonthCellComponent.ctorParameters = function () { return []; };
MonthCellComponent.propDecorators = {
    'day': [{ type: core.Input },],
    'openDay': [{ type: core.Input },],
    'locale': [{ type: core.Input },],
    'tooltipPlacement': [{ type: core.Input },],
    'tooltipAppendToBody': [{ type: core.Input },],
    'customTemplate': [{ type: core.Input },],
    'tooltipTemplate': [{ type: core.Input },],
    'highlightDay': [{ type: core.Output },],
    'unhighlightDay': [{ type: core.Output },],
    'eventClicked': [{ type: core.Output },],
};
var MonthViewHeaderComponent = (function () {
    function MonthViewHeaderComponent() {
    }
    return MonthViewHeaderComponent;
}());
MonthViewHeaderComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-month-view-header',
                template: "\n    <ng-template\n    #defaultTemplate\n    let-days=\"days\"\n    let-locale=\"locale\">\n    <div class=\"cal-cell-row cal-header\">\n      <div\n        class=\"cal-cell\"\n        *ngFor=\"let day of days\"\n        [class.cal-past]=\"day.isPast\"\n        [class.cal-today]=\"day.isToday\"\n        [class.cal-future]=\"day.isFuture\"\n        [class.cal-weekend]=\"day.isWeekend\"\n        [ngClass]=\"day.cssClass\">\n        {{ day.date | date: 'EE' }}\n      </div>\n    </div>\n    </ng-template>\n    <ng-template\n    [ngTemplateOutlet]=\"customTemplate || defaultTemplate\"\n    [ngTemplateOutletContext]=\"{days: days, locale: locale}\">\n    </ng-template>\n  ",
                styles: ["\n    .cal-header {\n        text-align: center;\n        font-weight: bolder;\n        padding-top: 5px;\n        padding-bottom: 5px;\n        border: 1px solid #e1e1e1;\n      }\n\n      .cal-cell-row:hover {\n        background-color: #fafafa;\n      }\n\n      .cal-header .cal-cell {\n        padding: 5px 0;\n        overflow: hidden;\n        text-overflow: ellipsis;\n        display: block;\n        white-space: nowrap;\n        font-size: 12px;\n      }\n\n      .cal-cell-row {\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n      }\n    \n      .cal-cell {\n        float: left;\n        -webkit-box-flex: 1;\n            -ms-flex: 1;\n                flex: 1;\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        -webkit-box-orient: vertical;\n        -webkit-box-direction: normal;\n            -ms-flex-direction: column;\n                flex-direction: column;\n        -webkit-box-align: stretch;\n            -ms-flex-align: stretch;\n                align-items: stretch;\n      }\n\n      .cal-cell-row {\n        border-bottom: 1px solid #e1e1e1;\n      }\n  "]
            },] },
];
/**
 * @nocollapse
 */
MonthViewHeaderComponent.ctorParameters = function () { return []; };
MonthViewHeaderComponent.propDecorators = {
    'days': [{ type: core.Input },],
    'locale': [{ type: core.Input },],
    'customTemplate': [{ type: core.Input },],
};
var OpenDayEventsComponent = (function () {
    function OpenDayEventsComponent() {
    }
    /**
     * @return {?}
     */
    OpenDayEventsComponent.prototype.ngOnInit = function () {
    };
    return OpenDayEventsComponent;
}());
OpenDayEventsComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-open-day-events',
                template: "\n    <p>\n      open-day-events works!\n    </p>\n  ",
                styles: ["\n\n  "]
            },] },
];
/**
 * @nocollapse
 */
OpenDayEventsComponent.ctorParameters = function () { return []; };
var MonthModule = (function () {
    function MonthModule() {
    }
    return MonthModule;
}());
MonthModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    ResizableModule,
                    DragAndDropModule
                ],
                declarations: [
                    MonthViewComponent,
                    MonthCellComponent,
                    MonthViewHeaderComponent,
                    OpenDayEventsComponent
                ],
                exports: [
                    MonthViewComponent
                ]
            },] },
];
/**
 * @nocollapse
 */
MonthModule.ctorParameters = function () { return []; };
var WeekViewComponent = (function () {
    /**
     * @param {?} cdr
     * @param {?} utils
     */
    function WeekViewComponent(cdr, utils) {
        this.cdr = cdr;
        this.utils = utils;
        /**
         * An array of events to display on view
         */
        this.events = [];
        /**
         * An array of day indexes (0 = sunday, 1 = monday etc) that will be hidden on the view
         */
        this.excludeDays = [];
        /**
         * @hidden
         */
        this.hours = [];
        /**
         * The precision to display events.
         * `days` will round event start and end dates to the nearest day and `minutes` will not do this rounding
         */
        this.precision = 'days';
        /**
         * The number of segments in an hour. Must be <= 6
         */
        this.hourSegments = 2;
        /**
         * The height in pixels of each hour segment
         */
        this.hourSegmentHeight = 30;
        /**
         * The day start hours in 24 hour time. Must be 0-23
         */
        this.dayStartHour = 0;
        /**
         * The day start minutes. Must be 0-59
         */
        this.dayStartMinute = 0;
        /**
         * The day end hours in 24 hour time. Must be 0-23
         */
        this.dayEndHour = 23;
        /**
         * The day end minutes. Must be 0-59
         */
        this.dayEndMinute = 59;
        /**
         * The width in pixels of each event on the view
         */
        this.eventWidth = 150;
        /**
         * An output that will be called before the view is rendered for the current week.
         * If you add the `cssClass` property to a day in the header it will add that class to the cell element in the template
         */
        this.beforeViewRender = new core.EventEmitter();
        /**
         * Called when the event title is clicked
         */
        this.eventClicked = new core.EventEmitter();
        this.currentTime = this.getCurrentTime();
    }
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.refresh) {
            this.refreshSubscription = this.refresh.subscribe(function () {
                _this.refreshAll();
                _this.cdr.markForCheck();
            });
        }
    };
    /**
     * @hidden
     * @param {?} changes
     * @return {?}
     */
    WeekViewComponent.prototype.ngOnChanges = function (changes) {
        if (changes.viewDate || changes.excludeDays || changes.weekendDays) {
            this.refreshHeader();
        }
        if (changes.events || changes.viewDate || changes.excludeDays) {
            this.refreshBody();
        }
    };
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.getCurrentTime = function () {
        var /** @type {?} */ time = new Date();
        var /** @type {?} */ top = dateFns.differenceInMinutes(time, dateFns.startOfDay(time));
        return top;
    };
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.refreshBody = function () {
        this.view = this.utils.getWeekView({
            events: this.events,
            viewDate: this.viewDate,
            hourSegments: this.hourSegments,
            dayStart: {
                hour: this.dayStartHour,
                minute: this.dayStartMinute
            },
            dayEnd: {
                hour: this.dayEndHour,
                minute: this.dayEndMinute
            },
            segmentHeight: this.hourSegmentHeight,
            weekStartsOn: this.weekStartsOn,
        });
    };
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.refreshHeader = function () {
        this.days = this.utils.getWeekViewHeader({
            viewDate: this.viewDate,
            weekStartsOn: this.weekStartsOn,
            excluded: this.excludeDays,
            weekendDays: this.weekendDays
        });
        this.hours = this.utils.getDayViewHourGrid({
            viewDate: this.viewDate,
            hourSegments: this.hourSegments,
            dayStart: {
                hour: this.dayStartHour,
                minute: this.dayStartMinute
            },
            dayEnd: {
                hour: this.dayEndHour,
                minute: this.dayEndMinute
            }
        });
        this.beforeViewRender.emit({
            header: this.days,
            body: this.hours
        });
    };
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.refreshAll = function () {
        this.refreshHeader();
        this.refreshBody();
    };
    return WeekViewComponent;
}());
WeekViewComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-week-view',
                template: "\n    <div class=\"calendar-week-view\">\n        <calendar-week-view-header\n        [days]=\"days\"\n        (eventClicked)=\"eventClicked.emit({event : $event.event})\"\n        [allDayEvents]=\"view?.allDays\">\n        </calendar-week-view-header>\n        <div class=\"cal-week-container\">\n            <div class=\"hour-segments\">\n                <div class=\"hour-segment-col\" *ngFor=\"let hour of hours\">\n                  {{ hour.segments[0].date | date: 'hh a' }}\n                </div>\n            </div>\n            <div class=\"days-container\">\n                <div\n                *ngFor=\"let day of view.days\"\n                [ngClass]=\"{'isToday': day.isToday }\"\n                class=\"day\">\n                <div *ngIf=\"day.isToday\"\n                [style.top.px]=\"currentTime\"\n                 class=\"currentTime\"></div>\n                <div\n                *ngFor=\"let hour of day.hours\" \n                class=\"day-hour\"></div>\n                <div\n                *ngFor=\"let event of day.events\"\n                >\n                    <div \n                    *ngIf=\"!event.event.allDay\"\n                    [style.top.px]=\"event.top\"\n                    [style.height.px]=\"event.height\"\n                    (click)=\"eventClicked.emit({event : event.event})\"\n                    [style.backgroundColor]=\"event.event.color ? event.event.color.primary : event.event.calendar.color\"\n                    class=\"day-event\">\n                        {{ event.event.title }}\n                    </div>\n                </div>\n                </div>\n            </div>\n        </div>\n    </div>\n  ",
                styles: ["\n    .calendar-week-view {\n      background-color: white;\n    }\n\n    .cal-week-container{\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n    }\n\n    .hour-segments{\n        height: 1440px;\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        -webkit-box-orient: vertical;\n        -webkit-box-direction: normal;\n            -ms-flex-direction: column;\n                flex-direction: column;\n        width: 50px;\n        border-right: 1px solid #dddddd;\n        border-left: 1px solid #dddddd;\n    }\n  \n    .hour-segment-col:first-child{\n      border-top: 1px solid #dddddd;\n    }\n    .hour-segment-col{\n        -webkit-box-flex: 1;\n            -ms-flex: 1;\n                flex: 1;\n        width: 48px;\n        border-bottom: 1px solid #dddddd;\n        background-color: white;\n        font-size: 12px;\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        -webkit-box-align: start;\n            -ms-flex-align: start;\n                align-items: flex-start;\n        -webkit-box-pack: end;\n            -ms-flex-pack: end;\n                justify-content: flex-end;\n        padding-right: 5px;\n    }\n    .days-container {\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1;\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      height: 1440px;\n    }\n\n    .day-hour {\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1;\n      border-bottom: 1px solid #dddddd;\n    }\n    .day {\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1;\n      border-right: 1px solid #dddddd;\n      height: 1440px;\n      position: relative;\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-box-orient: vertical;\n      -webkit-box-direction: normal;\n          -ms-flex-direction: column;\n              flex-direction: column; \n    }\n    .isToday {\n      background-color: #fafafa;\n    }\n    .day-event{\n      position: absolute;\n      width: 100%;\n      color:white;\n      font-size: 12px;\n      padding: 5px;\n      cursor: pointer;\n    }\n\n    .currentTime {\n      height: 2px;\n      width: 100%;\n      background-color: #DB4437;\n      position: absolute;\n    }\n  "]
            },] },
];
/**
 * @nocollapse
 */
WeekViewComponent.ctorParameters = function () { return [
    { type: core.ChangeDetectorRef, },
    { type: CalendarUtilsService, },
]; };
WeekViewComponent.propDecorators = {
    'viewDate': [{ type: core.Input },],
    'events': [{ type: core.Input },],
    'weekStartsOn': [{ type: core.Input },],
    'excludeDays': [{ type: core.Input },],
    'weekendDays': [{ type: core.Input },],
    'refresh': [{ type: core.Input },],
    'precision': [{ type: core.Input },],
    'hourSegments': [{ type: core.Input },],
    'hourSegmentHeight': [{ type: core.Input },],
    'dayStartHour': [{ type: core.Input },],
    'dayStartMinute': [{ type: core.Input },],
    'dayEndHour': [{ type: core.Input },],
    'dayEndMinute': [{ type: core.Input },],
    'eventWidth': [{ type: core.Input },],
    'beforeViewRender': [{ type: core.Output },],
    'eventClicked': [{ type: core.Output },],
};
var WeekViewHeaderComponent = (function () {
    function WeekViewHeaderComponent() {
        /**
         * Called when the event title is clicked
         */
        this.eventClicked = new core.EventEmitter();
        this.dayHeaderClicked = new core.EventEmitter();
        this.eventDropped = new core.EventEmitter();
    }
    return WeekViewHeaderComponent;
}());
WeekViewHeaderComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-week-view-header',
                template: "\n    <ng-template\n    #defaultTemplate\n    let-days=\"days\"\n    let-locale=\"locale\"\n    let-dayHeaderClicked=\"dayHeaderClicked\"\n    let-eventDropped=\"eventDropped\">\n    <div class=\"cal-week-day-headers\">\n    <div class=\"cal-day-headers\">\n      <div\n        class=\"cal-header\"\n        *ngFor=\"let day of days\"\n        [class.cal-past]=\"day.isPast\"\n        [class.cal-today]=\"day.isToday\"\n        [class.cal-future]=\"day.isFuture\"\n        [class.cal-weekend]=\"day.isWeekend\"\n        [class.cal-drag-over]=\"day.dragOver\"\n        [ngClass]=\"day.cssClass\"\n        (click)=\"dayHeaderClicked.emit({day: day})\"\n        mwlDroppable\n        (dragEnter)=\"day.dragOver = true\"\n        (dragLeave)=\"day.dragOver = false\"\n        (drop)=\"day.dragOver = false; eventDropped.emit({event: $event.dropData.event, newStart: day.date})\">\n        <b>{{ day.date | date:'E' }}</b><br>\n        <span>{{ day.date | date:'d' }}</span>\n      </div>\n    </div>\n    <div #eventRowContainer class=\"cal-events-row\">\n      <div\n      *ngFor=\"let weekEvent of allDayEvents\"\n      #event\n      class=\"cal-event-container\"\n      [style.width]=\"(((100 / days.length) * weekEvent.span)) + '%'\"\n      [style.marginLeft]=\"(((100 / days.length) * weekEvent.offset)) + '%'\"\n      [style.marginTop.px]=\"0\" \n      [style.height.px]=\"weekEvent.height -6\"\n      >\n      <div\n      class=\"cal-event\"\n      (click)=\"eventClicked.emit({event : weekEvent.event})\"\n      [class.cal-starts-within-week]=\"weekEvent.startsBeforeWeek\"\n      [class.cal-ends-within-week]=\"weekEvent.endsAfterWeek\"\n      [style.backgroundColor]=\"weekEvent.event.color ? weekEvent.event.color.primary : weekEvent.event.calendar.color\">\n        {{ weekEvent.event.title }}\n    </div>\n    </div>\n    </div>\n    </div>\n    </ng-template>\n    <ng-template\n    [ngTemplateOutlet]=\"defaultTemplate\"\n    [ngTemplateOutletContext]=\"{days: days, locale: locale, dayHeaderClicked: dayHeaderClicked, eventDropped: eventDropped}\">\n    </ng-template>\n  ",
                styles: ["\n    .cal-week-day-headers{\n        position: relative;\n        margin-left: 50px;\n      }\n    .cal-day-headers {\n          display: -webkit-box;\n          display: -ms-flexbox;\n          display: flex;\n          border: 1px solid #e1e1e1;\n          background-color: white;\n    }\n  \n    .cal-day-headers .cal-header {\n          -webkit-box-flex: 1;\n              -ms-flex: 1;\n                  flex: 1;\n          text-align: center;\n          padding: 5px 0;\n          font-size: 12px;\n    }\n\n    .cal-events-row{\n          border: 1px solid #e1e1e1;\n          background-color: white;\n          border-top: none;\n          position: relative;\n    }\n\n    .cal-event {\n          padding: 5px;\n          font-size: 12px;\n          overflow: hidden;\n          text-overflow: ellipsis;\n          white-space: nowrap;\n          height: 100%;\n          -webkit-box-sizing: border-box;\n                  box-sizing: border-box;\n          margin: 2px !important;\n          color: white;\n          cursor: pointer;\n        } \n  "]
            },] },
];
/**
 * @nocollapse
 */
WeekViewHeaderComponent.ctorParameters = function () { return []; };
WeekViewHeaderComponent.propDecorators = {
    'days': [{ type: core.Input },],
    'allDayEvents': [{ type: core.Input },],
    'locale': [{ type: core.Input },],
    'customTemplate': [{ type: core.Input },],
    'eventClicked': [{ type: core.Output },],
    'dayHeaderClicked': [{ type: core.Output },],
    'eventDropped': [{ type: core.Output },],
};
var WeekModule = (function () {
    function WeekModule() {
    }
    return WeekModule;
}());
WeekModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    WeekViewComponent,
                    WeekViewHeaderComponent
                ],
                exports: [
                    WeekViewComponent
                ]
            },] },
];
/**
 * @nocollapse
 */
WeekModule.ctorParameters = function () { return []; };
var ScheduleViewComponent = (function () {
    /**
     * @param {?} utils
     */
    function ScheduleViewComponent(utils) {
        this.utils = utils;
        /**
         * An array of events to display on view.
         */
        this.events = [];
        /**
         * Called when the event title is clicked
         */
        this.eventClicked = new core.EventEmitter();
    }
    /**
     * @return {?}
     */
    ScheduleViewComponent.prototype.ngOnInit = function () {
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ScheduleViewComponent.prototype.ngOnChanges = function (changes) {
        if (changes.viewDate ||
            changes.events) {
            this.refreshBody();
        }
    };
    /**
     * @return {?}
     */
    ScheduleViewComponent.prototype.refreshBody = function () {
        this.view = this.utils.getScheduleView({
            events: this.events,
            viewDate: this.viewDate,
        });
    };
    return ScheduleViewComponent;
}());
ScheduleViewComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-schedule-view',
                template: "\n    <div class=\"cal-schedule-view\">\n      <div class=\"cal-schedule-day\" *ngFor=\"let day of view\">\n          <div class=\"cal-schedule-event-date\">\n              <div class=\"cal-schedule-event-date-day\">{{ day.date | date:'EEE' }}</div>\n              <div class=\"cal-schedule-event-date-month\">{{ day.date | date:'MMM d' }}</div>\n          </div>\n          <div class=\"cal-schedule-events\">\n          <div class=\"cal-schedule-event\" *ngFor=\"let event of day.events\">\n              <div \n              [style.backgroundColor]=\"event.color ? event.color.primary : event.calendar.color\"\n              class=\"cal-schedule-event-color mr-2\">\n              </div>\n              <div class=\"cal-schedule-event-time\" *ngIf=\"!event.allDay\">\n                  {{ event.start | date:'hh:mm a' }} - {{ event.end | date:'hh:mm a' }}\n              </div>\n              <div class=\"cal-schedule-event-time\" *ngIf=\"event.allDay\">\n                  All day\n              </div>\n              <div class=\"cal-schedule-event-title\">\n                  {{ event.title }}\n              </div>\n          </div>\n          </div>\n      </div>\n    </div>\n  ",
                styles: ["\n    .cal-schedule-view {\n      border-left: 1px solid #dddddd;\n      border-top: 1px solid #dddddd;\n      border-right: 1px solid #dddddd; }\n\n    .cal-schedule-day {\n      border-bottom: 1px solid #dddddd;\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      padding: 10px; }\n\n    .cal-schedule-event {\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      padding-bottom: 5px;\n      -webkit-box-align: center;\n          -ms-flex-align: center;\n              align-items: center; }\n\n    .cal-schedule-event-date {\n      display: -webkit-box;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-box-orient: vertical;\n      -webkit-box-direction: normal;\n          -ms-flex-direction: column;\n              flex-direction: column;\n      font-size: 12px;\n      min-width: 50px; }\n\n    .cal-schedule-event-title {\n      font-size: 14px;\n      font-weight: bold;\n      -webkit-box-flex: 1;\n          -ms-flex: 1;\n              flex: 1; }\n\n    .cal-schedule-event-time {\n      font-size: 12px;\n      font-weight: normal;\n      min-width: 130px;\n      -webkit-box-align: center;\n          -ms-flex-align: center;\n              align-items: center; }\n\n    .cal-schedule-event-color {\n      height: 10px !important;\n      width: 10px !important;\n      border-radius: 50%; }\n  "]
            },] },
];
/**
 * @nocollapse
 */
ScheduleViewComponent.ctorParameters = function () { return [
    { type: CalendarUtilsService, },
]; };
ScheduleViewComponent.propDecorators = {
    'events': [{ type: core.Input },],
    'viewDate': [{ type: core.Input },],
    'refresh': [{ type: core.Input },],
    'eventClicked': [{ type: core.Output },],
};
var ScheduleModule = (function () {
    function ScheduleModule() {
    }
    return ScheduleModule;
}());
ScheduleModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [ScheduleViewComponent],
                exports: [ScheduleViewComponent]
            },] },
];
/**
 * @nocollapse
 */
ScheduleModule.ctorParameters = function () { return []; };
var CalendarHeaderComponent = (function () {
    function CalendarHeaderComponent() {
        this.locale = 'fr';
        this.viewChange = new core.EventEmitter();
        this.viewDateChange = new core.EventEmitter();
    }
    /**
     * @return {?}
     */
    CalendarHeaderComponent.prototype.ngOnInit = function () {
    };
    return CalendarHeaderComponent;
}());
CalendarHeaderComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'calendar-header',
                template: "\n\n    <div class=\"row p-2\">\n      <div class=\"col-md-3\"></div>\n        <div class=\"col-md-2\">\n          <div class=\"btn-group\">\n            <div\n              class=\"btn-circle\"\n              appCalendarPreviousView\n              [view]=\"view\"\n              [(viewDate)]=\"viewDate\"\n              (viewDateChange)=\"viewDateChange.next(viewDate)\">\n              <i class=\"fa fa-chevron-left\"></i>\n            </div>\n            <div\n              class=\"btn btn-today\"\n              appCalendarToday\n              [(viewDate)]=\"viewDate\"\n              (viewDateChange)=\"viewDateChange.next(viewDate)\">\n              Today\n            </div>\n            <div\n              class=\"btn-circle\"\n              appCalendarNextView\n              [view]=\"view\"\n              [(viewDate)]=\"viewDate\"\n              (viewDateChange)=\"viewDateChange.next(viewDate)\">\n              <i class=\"fa fa-chevron-right\"></i>\n            </div>\n          </div>\n        </div>\n        <div *ngIf=\"view === 'week' || view === 'month' || view === 'schedule'\" class=\"col-md-4 todate\">\n          {{ viewDate | date: 'MMMM yyyy' }}\n        </div>\n        <div *ngIf=\"view === 'day'\" class=\"col-md-4 todate\">\n            {{ viewDate | date: 'EEEE dd MMMM yyyy' }}\n        </div>\n        <div class=\"col-md-3\">\n          <div class=\"btn-group\">\n            <div\n              class=\"btn btn-view\"\n              (click)=\"viewChange.emit('month')\"\n              [class.active]=\"view === 'month'\">\n              Month\n            </div>\n            <div\n              class=\"btn btn-view\"\n              (click)=\"viewChange.emit('week')\"\n              [class.active]=\"view === 'week'\">\n              Week\n            </div>\n            <div\n              class=\"btn btn-view\"\n              (click)=\"viewChange.emit('day')\"\n              [class.active]=\"view === 'day'\">\n              Day\n            </div>\n            <div\n            class=\"btn btn-view\"\n            (click)=\"viewChange.emit('schedule')\"\n            [class.active]=\"view === 'schedule'\">\n            Schedule\n          </div>\n          </div>\n        </div>\n      </div>\n  ",
                styles: ["\n    .calendar-import-export{\n        position: relative;\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n    }\n\n    .todate {\n        color: #8F8F8F;\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        -webkit-box-pack: center;\n            -ms-flex-pack: center;\n                justify-content: center;\n    }\n\n    .btn {\n        border-radius :0; \n        cursor: pointer;\n    }\n    .btn-today { \n        background-color: #f2f2f2;\n        color: #8F8F8F;\n    }\n    .btn-circle {\n        height: 38px;\n        width: 38px;\n        border-radius: 50%;\n        background-color: #ffffff;\n        display: -webkit-box;\n        display: -ms-flexbox;\n        display: flex;\n        -webkit-box-align: center;\n            -ms-flex-align: center;\n                align-items: center;\n        -webkit-box-pack: center;\n            -ms-flex-pack: center;\n                justify-content: center;\n        cursor: pointer;\n        color: #8F8F8F;\n    }\n\n    .btn-circle:hover {\n        background-color: #f2f2f2;\n    }\n\n    .btn-view {\n        color: #8F8F8F;\n        background-color: #ffffff;\n    }\n\n    .btn-view.active, .btn-view:hover {\n        background-color: #f2f2f2;\n    }\n  "]
            },] },
];
/**
 * @nocollapse
 */
CalendarHeaderComponent.ctorParameters = function () { return []; };
CalendarHeaderComponent.propDecorators = {
    'view': [{ type: core.Input },],
    'viewDate': [{ type: core.Input },],
    'locale': [{ type: core.Input },],
    'events': [{ type: core.Input },],
    'viewChange': [{ type: core.Output },],
    'viewDateChange': [{ type: core.Output },],
};
/**
 * Change the view date to the next view. For example:
 *
 * ```typescript
 * <button
 *  appCalendarNextView
 *  [(viewDate)]="viewDate"
 *  [view]="view">
 *  Next
 * </button>
 * ```
 */
var CalendarNextViewDirective = (function () {
    function CalendarNextViewDirective() {
        /**
         * Called when the view date is changed
         */
        this.viewDateChange = new core.EventEmitter();
    }
    /**
     * @hidden
     * @return {?}
     */
    CalendarNextViewDirective.prototype.onClick = function () {
        var /** @type {?} */ addFn = {
            day: dateFns.addDays,
            week: dateFns.addWeeks,
            month: dateFns.addMonths,
            schedule: dateFns.addDays
        }[this.view];
        this.viewDateChange.emit(addFn(this.viewDate, 1));
    };
    return CalendarNextViewDirective;
}());
CalendarNextViewDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[appCalendarNextView]'
            },] },
];
/**
 * @nocollapse
 */
CalendarNextViewDirective.ctorParameters = function () { return []; };
CalendarNextViewDirective.propDecorators = {
    'view': [{ type: core.Input },],
    'viewDate': [{ type: core.Input },],
    'viewDateChange': [{ type: core.Output },],
    'onClick': [{ type: core.HostListener, args: ['click',] },],
};
/**
 * Change the view date to the previous view. For example:
 *
 * ```typescript
 * <button
 *  appCalendarPreviousView
 *  [(viewDate)]="viewDate"
 *  [view]="view">
 *  Previous
 * </button>
 * ```
 */
var CalendarPreviousViewDirective = (function () {
    function CalendarPreviousViewDirective() {
        /**
         * Called when the view date is changed
         */
        this.viewDateChange = new core.EventEmitter();
    }
    /**
     * @hidden
     * @return {?}
     */
    CalendarPreviousViewDirective.prototype.onClick = function () {
        var /** @type {?} */ subFn = {
            day: dateFns.subDays,
            week: dateFns.subWeeks,
            month: dateFns.subMonths,
            schedule: dateFns.subDays
        }[this.view];
        this.viewDateChange.emit(subFn(this.viewDate, 1));
    };
    return CalendarPreviousViewDirective;
}());
CalendarPreviousViewDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[appCalendarPreviousView]'
            },] },
];
/**
 * @nocollapse
 */
CalendarPreviousViewDirective.ctorParameters = function () { return []; };
CalendarPreviousViewDirective.propDecorators = {
    'view': [{ type: core.Input },],
    'viewDate': [{ type: core.Input },],
    'viewDateChange': [{ type: core.Output },],
    'onClick': [{ type: core.HostListener, args: ['click',] },],
};
/**
 * Change the view date to the current day. For example:
 *
 * ```typescript
 * <button
 *  appCalendarToday
 *  [(viewDate)]="viewDate">
 *  Today
 * </button>
 * ```
 */
var CalendarTodayDirective = (function () {
    function CalendarTodayDirective() {
        /**
         * Called when the view date is changed
         */
        this.viewDateChange = new core.EventEmitter();
    }
    /**
     * @hidden
     * @return {?}
     */
    CalendarTodayDirective.prototype.onClick = function () {
        this.viewDateChange.emit(dateFns.startOfToday());
    };
    return CalendarTodayDirective;
}());
CalendarTodayDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[appCalendarToday]'
            },] },
];
/**
 * @nocollapse
 */
CalendarTodayDirective.ctorParameters = function () { return []; };
CalendarTodayDirective.propDecorators = {
    'viewDate': [{ type: core.Input },],
    'viewDateChange': [{ type: core.Output },],
    'onClick': [{ type: core.HostListener, args: ['click',] },],
};
var HeaderModule = (function () {
    function HeaderModule() {
    }
    return HeaderModule;
}());
HeaderModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    CalendarHeaderComponent,
                    CalendarNextViewDirective,
                    CalendarPreviousViewDirective,
                    CalendarTodayDirective
                ],
                exports: [
                    CalendarHeaderComponent,
                    CalendarNextViewDirective,
                    CalendarPreviousViewDirective,
                    CalendarTodayDirective
                ]
            },] },
];
/**
 * @nocollapse
 */
HeaderModule.ctorParameters = function () { return []; };
var CalendarModule = (function () {
    function CalendarModule() {
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    CalendarModule.forRoot = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: CalendarModule,
            providers: [
                DraggableHelper,
                CalendarUtilsService
            ]
        };
    };
    return CalendarModule;
}());
CalendarModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    DayModule,
                    MonthModule,
                    WeekModule,
                    ScheduleModule,
                    HeaderModule,
                ],
                exports: [
                    DayModule,
                    MonthModule,
                    WeekModule,
                    ScheduleModule,
                    HeaderModule,
                ],
                declarations: []
            },] },
];
/**
 * @nocollapse
 */
CalendarModule.ctorParameters = function () { return []; };

exports.CalendarModule = CalendarModule;
exports.DayModule = DayModule;
exports.MonthModule = MonthModule;
exports.WeekModule = WeekModule;
exports.ScheduleModule = ScheduleModule;
exports.ɵf = EventActionComponent;
exports.ɵg = EventTitleComponent;
exports.ɵc = DayViewAllDayEventComponent;
exports.ɵd = DayViewEventComponent;
exports.ɵe = DayViewHourSegmentComponent;
exports.ɵa = DayViewComponent;
exports.ɵq = CalendarNextViewDirective;
exports.ɵr = CalendarPreviousViewDirective;
exports.ɵs = CalendarTodayDirective;
exports.ɵp = CalendarHeaderComponent;
exports.ɵo = HeaderModule;
exports.ɵi = MonthCellComponent;
exports.ɵj = MonthViewHeaderComponent;
exports.ɵh = MonthViewComponent;
exports.ɵk = OpenDayEventsComponent;
exports.ɵn = ScheduleViewComponent;
exports.ɵb = CalendarUtilsService;
exports.ɵm = WeekViewHeaderComponent;
exports.ɵl = WeekViewComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-calendar.umd.js.map
